



/* This file was generated by NEMO (http://wiki.call-cc.org/nemo) version 9.0
 on Thu Oct 23 15:24:41 2014 */


#include "Golgi.h"
#include "exceptions.h"
#include "network.h"
#include "dict.h"
#include "integerdatum.h"
#include "doubledatum.h"
#include "dictutils.h"
#include "numerics.h"
#include <limits>

#include "universal_data_logger_impl.h"

#include <iomanip>
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>

namespace nest {




  int fsolve (int (*fss)(const gsl_vector *, void *user_data, gsl_vector *), int N, gsl_vector *fval, void *user_data, std::string name)
  {
      
      const gsl_multiroot_fsolver_type * T = gsl_multiroot_fsolver_hybrid;
      gsl_multiroot_fsolver * s = gsl_multiroot_fsolver_alloc (T, N);
      gsl_multiroot_function f = {fss, N, user_data};

      int status, iter;
      gsl_vector *x = gsl_vector_alloc (N);
      
      for (int i = 0; i < N; i++)
      {
         gsl_vector_set (x, i, 0.0);
      }

      gsl_multiroot_fsolver_set (s, &f, x);

      iter = 0;
      do
      {
         iter++;
         status = gsl_multiroot_fsolver_iterate (s);

         if ((status == GSL_EBADFUNC) ||
             (status == GSL_ENOPROG))
         {
            throw GSLSolverFailure(name, status);
         }
         
         status =  gsl_multiroot_test_residual (s->f, 1e-7);
      }
      while (status == GSL_CONTINUE && iter < 1000);

      for (int i = 0; i < N; i++)
      {
         gsl_vector_set (fval, i, gsl_vector_get (s->x, i));
      }

      gsl_vector_free (x);
      gsl_multiroot_fsolver_free (s);

      return 0;
  }





double NaR_beta_s (double v, double Q10, const void* params);


double Na_beta_v (double v, double Q10, const void* params);


double Na_beta_u (double v, double Q10, const void* params);


double CaHVA_alpha_s (double v, double Q10, const void* params);


double CaHVA_alpha_u (double v, double Q10, const void* params);


double HCN2_tau_fast (double potential, double t1, double t2, double t3, const void* params);


double KA_beta_b (double v, double Q10, const void* params);


double KA_beta_a (double v, double Q10, const void* params);


double NaP_alpha_m (double v, double Q10, const void* params);


double KM_beta_n (double v, double Q10, const void* params);


double KA_alpha_a (double v, double Q10, const void* params);


double KA_alpha_b (double v, double Q10, const void* params);


double HCN2_o_inf (double potential, double Ehalf, double c, const void* params);


double NaP_beta_m (double v, double Q10, const void* params);


double KCa_beta_c (double v, double cai, double Q10, const void* params);


double HCN1_o_inf (double potential, double Ehalf, double c, const void* params);


double NaP_linoid (double x, double y, const void* params);


double HCN2_tau_slow (double potential, double t1, double t2, double t3, const void* params);


double HCN1_tau (double potential, double t1, double t2, double t3, const void* params);


double NaR_beta_f (double v, double Q10, const void* params);


double KCa_alpha_c (double v, double cai, double Q10, const void* params);


double NaR_alpha_f (double v, double Q10, const void* params);


double NaR_alpha_s (double v, double Q10, const void* params);


double Na_linoid (double x, double y, const void* params);


double KV_linoid (double x, double y, const void* params);


double KV_alpha_n (double v, double Q10, const void* params);


double CaHVA_beta_s (double v, double Q10, const void* params);


double CaHVA_beta_u (double v, double Q10, const void* params);


double HCN2_r (double potential, double r1, double r2, const void* params);


double KM_alpha_n (double v, double Q10, const void* params);


double Na_alpha_u (double v, double Q10, const void* params);


double Na_alpha_v (double v, double Q10, const void* params);


double HCN1_r (double potential, const void* params);


double KA_sigm (double x, double y, const void* params);


double KV_beta_n (double v, double Q10, const void* params);



double NaR_beta_s (double v, double Q10, const void* params) {

  double rv317;

  double v320, v319;
  double NaR_V0beta_s, NaR_Abeta_s, NaR_Shiftbeta_s, NaR_Kbeta_s;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaR_V0beta_s =  p.NaR_V0beta_s;
  NaR_Abeta_s =  p.NaR_Abeta_s;
  NaR_Shiftbeta_s =  p.NaR_Shiftbeta_s;
  NaR_Kbeta_s =  p.NaR_Kbeta_s;
  v319  =  (v + NaR_V0beta_s) / NaR_Kbeta_s;; 
if (v319 > 200.0) {v320  =  200.0;} else {v320  =  v319;}; 
  rv317  =  Q10 * (NaR_Shiftbeta_s + NaR_Abeta_s * (v + NaR_V0beta_s) / (exp(v320) + -1.0));  return rv317;
}


double Na_beta_v (double v, double Q10, const void* params) {

  double rv321;

  double Na_Kbeta_v, Na_V0beta_v, Na_Abeta_v;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  Na_Kbeta_v =  p.Na_Kbeta_v;
  Na_V0beta_v =  p.Na_V0beta_v;
  Na_Abeta_v =  p.Na_Abeta_v;
  rv321  =  (Q10 * Na_Abeta_v) / (1.0 + exp((v + -(Na_V0beta_v)) / Na_Kbeta_v));  return rv321;
}


double Na_beta_u (double v, double Q10, const void* params) {

  double rv322;

  double Na_Kbeta_u, Na_V0beta_u, Na_Abeta_u;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  Na_Kbeta_u =  p.Na_Kbeta_u;
  Na_V0beta_u =  p.Na_V0beta_u;
  Na_Abeta_u =  p.Na_Abeta_u;
  rv322  =  Q10 * Na_Abeta_u * exp((v + -(Na_V0beta_u)) / Na_Kbeta_u);  return rv322;
}


double CaHVA_alpha_s (double v, double Q10, const void* params) {

  double rv323;

  double CaHVA_Kalpha_s, CaHVA_V0alpha_s, CaHVA_Aalpha_s;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  CaHVA_Kalpha_s =  p.CaHVA_Kalpha_s;
  CaHVA_V0alpha_s =  p.CaHVA_V0alpha_s;
  CaHVA_Aalpha_s =  p.CaHVA_Aalpha_s;
  rv323  =  Q10 * CaHVA_Aalpha_s * exp((v + -(CaHVA_V0alpha_s)) / CaHVA_Kalpha_s);  return rv323;
}


double CaHVA_alpha_u (double v, double Q10, const void* params) {

  double rv324;

  double CaHVA_Kalpha_u, CaHVA_V0alpha_u, CaHVA_Aalpha_u;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  CaHVA_Kalpha_u =  p.CaHVA_Kalpha_u;
  CaHVA_V0alpha_u =  p.CaHVA_V0alpha_u;
  CaHVA_Aalpha_u =  p.CaHVA_Aalpha_u;
  rv324  =  Q10 * CaHVA_Aalpha_u * exp((v + -(CaHVA_V0alpha_u)) / CaHVA_Kalpha_u);  return rv324;
}


double HCN2_tau_fast (double potential, double t1, double t2, double t3, const void* params) {

  double rv325;

  rv325  =  exp(t3 * (t1 * potential + -(t2)));  return rv325;
}


double KA_beta_b (double v, double Q10, const void* params) {

  double rv326;

  double KA_Kbeta_b, KA_V0beta_b, KA_Abeta_b;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KA_Kbeta_b =  p.KA_Kbeta_b;
  KA_V0beta_b =  p.KA_V0beta_b;
  KA_Abeta_b =  p.KA_Abeta_b;
  rv326  =  Q10 * KA_Abeta_b * KA_sigm(v + -(KA_V0beta_b), KA_Kbeta_b, params);  return rv326;
}


double KA_beta_a (double v, double Q10, const void* params) {

  double rv327;

  double KA_Kbeta_a, KA_V0beta_a, KA_Abeta_a;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KA_Kbeta_a =  p.KA_Kbeta_a;
  KA_V0beta_a =  p.KA_V0beta_a;
  KA_Abeta_a =  p.KA_Abeta_a;
  rv327  =  Q10 * KA_Abeta_a / exp((v + -(KA_V0beta_a)) / KA_Kbeta_a);  return rv327;
}


double NaP_alpha_m (double v, double Q10, const void* params) {

  double rv328;

  double NaP_Kalpha_m, NaP_V0alpha_m, NaP_Aalpha_m;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaP_Kalpha_m =  p.NaP_Kalpha_m;
  NaP_V0alpha_m =  p.NaP_V0alpha_m;
  NaP_Aalpha_m =  p.NaP_Aalpha_m;
  rv328  =  Q10 * NaP_Aalpha_m * NaP_linoid(v + -(NaP_V0alpha_m), NaP_Kalpha_m, params);  return rv328;
}


double KM_beta_n (double v, double Q10, const void* params) {

  double rv329;

  double KM_Kbeta_n, KM_V0beta_n, KM_Abeta_n;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KM_Kbeta_n =  p.KM_Kbeta_n;
  KM_V0beta_n =  p.KM_V0beta_n;
  KM_Abeta_n =  p.KM_Abeta_n;
  rv329  =  Q10 * KM_Abeta_n * exp((v + -(KM_V0beta_n)) / KM_Kbeta_n);  return rv329;
}


double KA_alpha_a (double v, double Q10, const void* params) {

  double rv330;

  double KA_Kalpha_a, KA_V0alpha_a, KA_Aalpha_a;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KA_Kalpha_a =  p.KA_Kalpha_a;
  KA_V0alpha_a =  p.KA_V0alpha_a;
  KA_Aalpha_a =  p.KA_Aalpha_a;
  rv330  =  Q10 * KA_Aalpha_a * KA_sigm(v + -(KA_V0alpha_a), KA_Kalpha_a, params);  return rv330;
}


double KA_alpha_b (double v, double Q10, const void* params) {

  double rv331;

  double KA_Kalpha_b, KA_V0alpha_b, KA_Aalpha_b;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KA_Kalpha_b =  p.KA_Kalpha_b;
  KA_V0alpha_b =  p.KA_V0alpha_b;
  KA_Aalpha_b =  p.KA_Aalpha_b;
  rv331  =  Q10 * KA_Aalpha_b * KA_sigm(v + -(KA_V0alpha_b), KA_Kalpha_b, params);  return rv331;
}


double HCN2_o_inf (double potential, double Ehalf, double c, const void* params) {

  double rv332;

  rv332  =  1.0 / (1.0 + exp((potential + -(Ehalf)) * c));  return rv332;
}


double NaP_beta_m (double v, double Q10, const void* params) {

  double rv333;

  double NaP_Kbeta_m, NaP_V0beta_m, NaP_Abeta_m;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaP_Kbeta_m =  p.NaP_Kbeta_m;
  NaP_V0beta_m =  p.NaP_V0beta_m;
  NaP_Abeta_m =  p.NaP_Abeta_m;
  rv333  =  Q10 * NaP_Abeta_m * NaP_linoid(v + -(NaP_V0beta_m), NaP_Kbeta_m, params);  return rv333;
}


double KCa_beta_c (double v, double cai, double Q10, const void* params) {

  double rv334;

  double KCa_Kbeta_c, KCa_Bbeta_c, KCa_Abeta_c;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KCa_Kbeta_c =  p.KCa_Kbeta_c;
  KCa_Bbeta_c =  p.KCa_Bbeta_c;
  KCa_Abeta_c =  p.KCa_Abeta_c;
  rv334  =  (Q10 * KCa_Abeta_c) / (1.0 + cai / (KCa_Bbeta_c * exp(v / KCa_Kbeta_c)));  return rv334;
}


double HCN1_o_inf (double potential, double Ehalf, double c, const void* params) {

  double rv335;

  rv335  =  1.0 / (1.0 + exp((potential + -(Ehalf)) * c));  return rv335;
}


double NaP_linoid (double x, double y, const void* params) {

  double rv336;

  double v338;
  if (fabs(x / y) < 1e-06) 
      {v338  =  y * (1.0 + -(x / y / 2.0));} 
      else 
        {v338  =  x / (exp(x / y) + -1.0);}; 
rv336  =  v338;  return rv336;
}


double HCN2_tau_slow (double potential, double t1, double t2, double t3, const void* params) {

  double rv339;

  rv339  =  exp(t3 * (t1 * potential + -(t2)));  return rv339;
}


double HCN1_tau (double potential, double t1, double t2, double t3, const void* params) {

  double rv340;

  rv340  =  exp((t1 * potential + -(t2)) * t3);  return rv340;
}


double NaR_beta_f (double v, double Q10, const void* params) {

  double rv341;

  double NaR_Kbeta_f, NaR_V0beta_f, NaR_Abeta_f;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaR_Kbeta_f =  p.NaR_Kbeta_f;
  NaR_V0beta_f =  p.NaR_V0beta_f;
  NaR_Abeta_f =  p.NaR_Abeta_f;
  rv341  =  Q10 * NaR_Abeta_f * exp((v + -(NaR_V0beta_f)) / NaR_Kbeta_f);  return rv341;
}


double KCa_alpha_c (double v, double cai, double Q10, const void* params) {

  double rv342;

  double KCa_Kalpha_c, KCa_Balpha_c, KCa_Aalpha_c;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KCa_Kalpha_c =  p.KCa_Kalpha_c;
  KCa_Balpha_c =  p.KCa_Balpha_c;
  KCa_Aalpha_c =  p.KCa_Aalpha_c;
  rv342  =  (Q10 * KCa_Aalpha_c) / (1.0 + (KCa_Balpha_c * exp(v / KCa_Kalpha_c)) / cai);  return rv342;
}


double NaR_alpha_f (double v, double Q10, const void* params) {

  double rv343;

  double NaR_Kalpha_f, NaR_V0alpha_f, NaR_Aalpha_f;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaR_Kalpha_f =  p.NaR_Kalpha_f;
  NaR_V0alpha_f =  p.NaR_V0alpha_f;
  NaR_Aalpha_f =  p.NaR_Aalpha_f;
  rv343  =  Q10 * NaR_Aalpha_f * exp((v + -(NaR_V0alpha_f)) / NaR_Kalpha_f);  return rv343;
}


double NaR_alpha_s (double v, double Q10, const void* params) {

  double rv344;

  double NaR_Kalpha_s, NaR_V0alpha_s, NaR_Aalpha_s, NaR_Shiftalpha_s;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  NaR_Kalpha_s =  p.NaR_Kalpha_s;
  NaR_V0alpha_s =  p.NaR_V0alpha_s;
  NaR_Aalpha_s =  p.NaR_Aalpha_s;
  NaR_Shiftalpha_s =  p.NaR_Shiftalpha_s;
  rv344  =  Q10 * (NaR_Shiftalpha_s + (NaR_Aalpha_s * (v + NaR_V0alpha_s)) / (exp((v + NaR_V0alpha_s) / NaR_Kalpha_s) + -1.0));  return rv344;
}


double Na_linoid (double x, double y, const void* params) {

  double rv345;

  double v347;
  if (fabs(x / y) < 1e-06) 
      {v347  =  y * (1.0 + -(x / y / 2.0));} 
      else 
        {v347  =  x / (1.0 + -(exp(x / y)));}; 
rv345  =  v347;  return rv345;
}


double KV_linoid (double x, double y, const void* params) {

  double rv348;

  double v350;
  if (fabs(x / y) < 1e-06) 
      {v350  =  y * (1.0 + -(x / y / 2.0));} 
      else 
        {v350  =  x / (exp(x / y) + -1.0);}; 
rv348  =  v350;  return rv348;
}


double KV_alpha_n (double v, double Q10, const void* params) {

  double rv351;

  double KV_Kalpha_n, KV_V0alpha_n, KV_Aalpha_n;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KV_Kalpha_n =  p.KV_Kalpha_n;
  KV_V0alpha_n =  p.KV_V0alpha_n;
  KV_Aalpha_n =  p.KV_Aalpha_n;
  rv351  =  Q10 * KV_Aalpha_n * KV_linoid(v + -(KV_V0alpha_n), KV_Kalpha_n, params);  return rv351;
}


double CaHVA_beta_s (double v, double Q10, const void* params) {

  double rv352;

  double CaHVA_Kbeta_s, CaHVA_V0beta_s, CaHVA_Abeta_s;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  CaHVA_Kbeta_s =  p.CaHVA_Kbeta_s;
  CaHVA_V0beta_s =  p.CaHVA_V0beta_s;
  CaHVA_Abeta_s =  p.CaHVA_Abeta_s;
  rv352  =  Q10 * CaHVA_Abeta_s * exp((v + -(CaHVA_V0beta_s)) / CaHVA_Kbeta_s);  return rv352;
}


double CaHVA_beta_u (double v, double Q10, const void* params) {

  double rv353;

  double CaHVA_Kbeta_u, CaHVA_V0beta_u, CaHVA_Abeta_u;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  CaHVA_Kbeta_u =  p.CaHVA_Kbeta_u;
  CaHVA_V0beta_u =  p.CaHVA_V0beta_u;
  CaHVA_Abeta_u =  p.CaHVA_Abeta_u;
  rv353  =  Q10 * CaHVA_Abeta_u * exp((v + -(CaHVA_V0beta_u)) / CaHVA_Kbeta_u);  return rv353;
}


double HCN2_r (double potential, double r1, double r2, const void* params) {

  double rv354;

  double v357, v358;
  if (potential >= -64.7) 
      {v357  =  0.0;} 
      else 
        {if (potential <= -108.7) 
                {v358  =  1.0;} 
                else 
                  {v358  =  r1 * potential + r2;}; 
          v357  =  v358;}; 
rv354  =  v357;  return rv354;
}


double KM_alpha_n (double v, double Q10, const void* params) {

  double rv359;

  double KM_Kalpha_n, KM_V0alpha_n, KM_Aalpha_n;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KM_Kalpha_n =  p.KM_Kalpha_n;
  KM_V0alpha_n =  p.KM_V0alpha_n;
  KM_Aalpha_n =  p.KM_Aalpha_n;
  rv359  =  Q10 * KM_Aalpha_n * exp((v + -(KM_V0alpha_n)) / KM_Kalpha_n);  return rv359;
}


double Na_alpha_u (double v, double Q10, const void* params) {

  double rv360;

  double Na_Kalpha_u, Na_V0alpha_u, Na_Aalpha_u;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  Na_Kalpha_u =  p.Na_Kalpha_u;
  Na_V0alpha_u =  p.Na_V0alpha_u;
  Na_Aalpha_u =  p.Na_Aalpha_u;
  rv360  =  Q10 * Na_Aalpha_u * Na_linoid(v + -(Na_V0alpha_u), Na_Kalpha_u, params);  return rv360;
}


double Na_alpha_v (double v, double Q10, const void* params) {

  double rv361;

  double Na_Kalpha_v, Na_V0alpha_v, Na_Aalpha_v;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  Na_Kalpha_v =  p.Na_Kalpha_v;
  Na_V0alpha_v =  p.Na_V0alpha_v;
  Na_Aalpha_v =  p.Na_Aalpha_v;
  rv361  =  Q10 * Na_Aalpha_v * exp((v + -(Na_V0alpha_v)) / Na_Kalpha_v);  return rv361;
}


double HCN1_r (double potential, const void* params) {

  double rv362;

  double HCN1_rB, HCN1_rA;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  HCN1_rB =  p.HCN1_rB;
  HCN1_rA =  p.HCN1_rA;
  rv362  =  HCN1_rA * potential + HCN1_rB;  return rv362;
}


double KA_sigm (double x, double y, const void* params) {

  double rv363;

  rv363  =  1.0 / (exp(x / y) + 1.0);  return rv363;
}


double KV_beta_n (double v, double Q10, const void* params) {

  double rv364;

  double KV_Kbeta_n, KV_V0beta_n, KV_Abeta_n;
  const Golgi::Parameters_ & p = *(reinterpret_cast< const Golgi::Parameters_ *>(params));

  KV_Kbeta_n =  p.KV_Kbeta_n;
  KV_V0beta_n =  p.KV_V0beta_n;
  KV_Abeta_n =  p.KV_Abeta_n;
  rv364  =  Q10 * KV_Abeta_n * exp((v + -(KV_V0beta_n)) / KV_Kbeta_n);  return rv364;
}





extern "C" int Golgi_dynamics (double t, const double y[], double f[], void* pnode)
{

   double v310, ca2_ca2, ca2i, CaLVA_ca2i, ca2_ca2o, ca2o, CaLVA_ca2o, CaLVA_F, comp19_celsius, CaLVA_R, CaLVA_e, v, CaLVA_h270, CaLVA_m269, CaLVA_gbar, i_CaLVA, ica2, ca2_ica2, ca_ca, cai, KCa_cai, SK2_cai, CaHVA_cai, ca_cao, cao, CaHVA_cao, CaHVA_F, CaHVA_R, CaHVA_e, CaHVA_h264, CaHVA_m263, CaHVA_g, i_CaHVA, ica, ca_ica, NaR_Q10, HCN1_c, HCN1_Ehalf, HCN1_o_slow_inf, KCa_Q10, Na_Q10, CaHVA_Q10, HCN1_tEs, HCN1_tDs, HCN1_tCs, HCN1_tau_s, HCN1_tEf, HCN1_tDf, HCN1_tCf, HCN1_tau_f, HCN1_o_fast_inf, NaP_B_minf, NaP_V0_minf, NaP_m_inf298, KA_Q10, CaLVA_k_m_inf, CaLVA_v0_m_inf, CaLVA_shift, CaLVA_m_inf, HCN2_c, HCN2_Ehalf, HCN2_rB, HCN2_rA, HCN2_o_slow_inf, CaLVA_phi_m, CaLVA_phi_h, NaP_Q10, KM_B_ninf, KM_V0_ninf, KM_m_inf282, CaLVA_k_h_inf, CaLVA_v0_h_inf, CaLVA_h_inf, HCN2_o_fast_inf, KV_Q10, SK2_Q10, HCN2_tEs, HCN2_tDs, HCN2_tCs, HCN2_tau_s, KM_Q10, AMPA_A, AMPA_B, AMPA_g, HCN2_tEf, HCN2_tDf, HCN2_tCf, HCN2_tau_f, KA_K_ainf, KA_V0_ainf, KA_a_inf, KA_K_binf, KA_V0_binf, KA_b_inf, KM_m_tau283, CaHVA_tau_s, CaHVA_tau_u, KV_tau_n, CaLVA_h_inf267, KCa_c_inf, Na_v_inf, SK2_dirc3, SK2_dirc3_t, NaR_tau_s, KA_h_inf273, NaR_tau_f, NaP_m_tau299, KA_tau_b, KA_tau_a, SK2_dirc2, SK2_dirc2_t, SK2_invc3, SK2_invc3_t, SK2_dirc4, SK2_dirc4_t, SK2_invo1, SK2_invo1_t, KV_n_inf, KCa_tau_c, CaLVA_k_tau_h2, CaLVA_v0_tau_h2, CaLVA_k_tau_h1, CaLVA_v0_tau_h1, CaLVA_A_tau_h, CaLVA_C_tau_h, CaLVA_tau_h, CaHVA_u_inf, Na_tau_v, Na_tau_u, CaLVA_k_tau_m2, CaLVA_v0_tau_m2, CaLVA_k_tau_m1, CaLVA_v0_tau_m1, CaLVA_A_tau_m, CaLVA_C_tau_m, CaLVA_tau_m, NaR_s_inf, Na_u_inf, SK2_diro2, SK2_diro2_t, CaLVA_m_inf265, SK2_invc1, SK2_invc1_t, SK2_invo2, SK2_invo2_t, SK2_diro1, SK2_diro1_t, CaHVA_s_inf, NaR_f_inf, SK2_invc2, SK2_invc2_t, KA_m_inf271, KA_m_tau272, SK2_diff, SK2_dirc3_t_ca, CaHVA_h_inf261, KV_m_inf287, CaHVA_h_tau262, Na_m_inf292, KCa_m_tau278, Na_h_tau295, Na_h_inf294, NaR_h_inf305, NaR_m_inf303, NaR_h_tau306, CaHVA_m_tau260, KA_h_tau274, SK2_dirc2_t_ca, KV_m_tau288, NaR_m_tau304, Na_m_tau293, SK2_dirc4_t_ca, CaHVA_m_inf259, KCa_m_inf277, CaLVA_m_tau266, CaLVA_h_tau268, SK2_SK2_zo2, SK2_SK2_zo1, SK2_SK2_z, AMPA_e, comp21_diam, comp21_L, i_AMPA, Lkg_erev, Lkg_gbar, i_Lkg, HCN1_erev, HCN1_o_fast, HCN1_o_slow, HCN1_gbar, i_HCN1, HCN2_erev, HCN2_o_fast, HCN2_o_slow, HCN2_gbar, i_HCN2, i, NaP_erev, NaP_m302, NaP_gbar, i_NaP, NaR_erev, NaR_h308, NaR_m307, NaR_gbar, i_NaR, Na_erev, Na_h297, Na_m296, Na_gbar, i_Na, ina, KA_erev, KA_h276, KA_m275, KA_gbar, i_KA, KCa_erev, KCa_m281, KCa_gbar, i_KCa, KM_erev, KM_m286, KM_gbar, i_KM, KV_erev, KV_m291, KV_gbar, i_KV, SK2_erev, SK2_gbar, i_SK2, ik, SK2_SK2_zc4, SK2_SK2_zc3, SK2_SK2_zc2, KM_V0beta_n, Na_V0alpha_u, NaR_Shiftalpha_s, NaR_Aalpha_f, KA_Kalpha_b, KA_Kalpha_a, KCa_Kbeta_c, KV_Abeta_n, KM_Kalpha_n, KA_g, KA_e, Lkg_e, Lkg_g, KA_Abeta_b, NaR_V0alpha_f, KA_Abeta_a, NaR_V0alpha_s, CaLVA_g, NaP_V0alpha_m, CaHVA_Aalpha_s, CaHVA_Aalpha_u, KA_Kbeta_a, KA_Kbeta_b, AMPA_scale_factor, ca_d, AMPA_tp, AMPA_tau1, AMPA_tau2, ca_F, KA_V0alpha_b, KA_V0alpha_a, KA_Aalpha_b, KA_Aalpha_a, KM_Kbeta_n, HCN1_rB, HCN1_rA, AMPA_tauA, AMPA_tauB, NaR_Abeta_s, comp19_V_t, NaR_Abeta_f, Na_e, Na_g, NaR_Kalpha_f, NaR_Kalpha_s, KV_Aalpha_n, KCa_Bbeta_c, NaR_e, NaR_g, KCa_Abeta_c, CaHVA_gbar, KCa_g, KCa_e, NaP_Kalpha_m, ca_cai0, KV_V0beta_n, KA_V0beta_b, KA_V0beta_a, NaP_g, NaP_e, KCa_Aalpha_c, ca2_ca2i0, NaR_V0beta_s, KV_Kbeta_n, NaR_Aalpha_s, Na_Kbeta_u, Na_Kbeta_v, KCa_Kalpha_c, comp20_c, CaLVA_valence, NaP_Aalpha_m, ca2_beta, NaP_V0beta_m, KV_Kalpha_n, HCN2_e, HCN2_g, NaP_Abeta_m, NaR_V0beta_f, CaHVA_Abeta_u, ca2_d, SK2_g, HCN1_e, SK2_e, HCN1_g, ca2_F, KM_Abeta_n, KM_V0alpha_n, CaHVA_V0alpha_s, NaP_Kbeta_m, CaHVA_Abeta_s, CaHVA_V0alpha_u, Na_Aalpha_u, Na_Aalpha_v, NaR_Kbeta_f, NaR_Kbeta_s, CaHVA_V0beta_u, CaHVA_V0beta_s, ca_beta, CaHVA_Kalpha_s, CaHVA_Kalpha_u, KV_g, KV_e, KCa_Balpha_c, NaR_Shiftbeta_s, KM_e, Na_V0beta_u, KM_g, Na_V0beta_v, KV_V0alpha_n, ca2_valence, Na_Kalpha_u, Na_Kalpha_v, KM_Aalpha_n, Na_Abeta_v, Na_Abeta_u, CaHVA_Kbeta_u, CaHVA_Kbeta_s, Na_V0alpha_v;

   // S is shorthand for the type that describes the model state
   typedef Golgi::State_ S;
	
   // cast the node ptr to an object of the proper type
   assert(pnode);
   const Golgi & node =  *(reinterpret_cast<Golgi*>(pnode));
   Golgi & vnode =  *(reinterpret_cast<Golgi*>(pnode));

   // params is a reference to the model parameters
   const struct Golgi::Parameters_ *params;
   params = &(node.P_);

   // state is a reference to the model state
   struct Golgi::State_ *state;
   state = &(vnode.S_);
	
   // y[] must be the state vector supplied by the integrator,
   // not the state vector in the node, node.S_.y[].

   KM_V0beta_n  =  params->KM_V0beta_n;
   Na_V0alpha_u  =  params->Na_V0alpha_u;
   NaR_Shiftalpha_s  =  params->NaR_Shiftalpha_s;
   AMPA_e  =  params->AMPA_e;
   NaR_Aalpha_f  =  params->NaR_Aalpha_f;
   CaLVA_k_m_inf  =  params->CaLVA_k_m_inf;
   KA_Kalpha_b  =  params->KA_Kalpha_b;
   KA_Kalpha_a  =  params->KA_Kalpha_a;
   KCa_Kbeta_c  =  params->KCa_Kbeta_c;
   SK2_invo1  =  params->SK2_invo1;
   SK2_invo2  =  params->SK2_invo2;
   SK2_gbar  =  params->SK2_gbar;
   KV_Abeta_n  =  params->KV_Abeta_n;
   KM_Kalpha_n  =  params->KM_Kalpha_n;
   KA_g  =  params->KA_g;
   KA_e  =  params->KA_e;
   Lkg_e  =  params->Lkg_e;
   Lkg_g  =  params->Lkg_g;
   HCN1_tEf  =  params->HCN1_tEf;
   KA_Abeta_b  =  params->KA_Abeta_b;
   NaR_V0alpha_f  =  params->NaR_V0alpha_f;
   KA_Abeta_a  =  params->KA_Abeta_a;
   NaR_V0alpha_s  =  params->NaR_V0alpha_s;
   CaLVA_F  =  params->CaLVA_F;
   HCN1_tEs  =  params->HCN1_tEs;
   KM_B_ninf  =  params->KM_B_ninf;
   CaLVA_R  =  params->CaLVA_R;
   HCN1_tDs  =  params->HCN1_tDs;
   CaLVA_g  =  params->CaLVA_g;
   NaP_V0alpha_m  =  params->NaP_V0alpha_m;
   SK2_diro1  =  params->SK2_diro1;
   CaHVA_Aalpha_s  =  params->CaHVA_Aalpha_s;
   CaHVA_Aalpha_u  =  params->CaHVA_Aalpha_u;
   SK2_diro2  =  params->SK2_diro2;
   HCN2_erev  =  params->HCN2_erev;
   HCN1_Ehalf  =  params->HCN1_Ehalf;
   KA_V0_binf  =  params->KA_V0_binf;
   KA_Kbeta_a  =  params->KA_Kbeta_a;
   KA_Kbeta_b  =  params->KA_Kbeta_b;
   Lkg_gbar  =  params->Lkg_gbar;
   KM_gbar  =  params->KM_gbar;
   AMPA_scale_factor  =  params->AMPA_scale_factor;
   Na_gbar  =  params->Na_gbar;
   CaLVA_v0_m_inf  =  params->CaLVA_v0_m_inf;
   NaP_gbar  =  params->NaP_gbar;
   ca_d  =  params->ca_d;
   AMPA_tp  =  params->AMPA_tp;
   HCN2_tCs  =  params->HCN2_tCs;
   CaLVA_k_h_inf  =  params->CaLVA_k_h_inf;
   Na_erev  =  params->Na_erev;
   NaP_V0_minf  =  params->NaP_V0_minf;
   NaR_gbar  =  params->NaR_gbar;
   AMPA_tau1  =  params->AMPA_tau1;
   AMPA_tau2  =  params->AMPA_tau2;
   ca_F  =  params->ca_F;
   KA_V0alpha_b  =  params->KA_V0alpha_b;
   KA_V0alpha_a  =  params->KA_V0alpha_a;
   KA_Aalpha_b  =  params->KA_Aalpha_b;
   KA_Aalpha_a  =  params->KA_Aalpha_a;
   KM_Kbeta_n  =  params->KM_Kbeta_n;
   CaLVA_v0_tau_m1  =  params->CaLVA_v0_tau_m1;
   CaLVA_v0_tau_m2  =  params->CaLVA_v0_tau_m2;
   KA_gbar  =  params->KA_gbar;
   KA_erev  =  params->KA_erev;
   HCN1_rB  =  params->HCN1_rB;
   HCN1_rA  =  params->HCN1_rA;
   KA_V0_ainf  =  params->KA_V0_ainf;
   AMPA_tauA  =  params->AMPA_tauA;
   AMPA_tauB  =  params->AMPA_tauB;
   CaLVA_v0_tau_h2  =  params->CaLVA_v0_tau_h2;
   CaLVA_v0_tau_h1  =  params->CaLVA_v0_tau_h1;
   NaR_Abeta_s  =  params->NaR_Abeta_s;
   comp19_V_t  =  params->comp19_V_t;
   HCN2_Ehalf  =  params->HCN2_Ehalf;
   CaLVA_v0_h_inf  =  params->CaLVA_v0_h_inf;
   NaR_Abeta_f  =  params->NaR_Abeta_f;
   ca2_ca2o  =  params->ca2_ca2o;
   Na_e  =  params->Na_e;
   Na_g  =  params->Na_g;
   NaR_Kalpha_f  =  params->NaR_Kalpha_f;
   SK2_dirc4  =  params->SK2_dirc4;
   SK2_dirc3  =  params->SK2_dirc3;
   SK2_dirc2  =  params->SK2_dirc2;
   NaR_Kalpha_s  =  params->NaR_Kalpha_s;
   KV_Aalpha_n  =  params->KV_Aalpha_n;
   KCa_Bbeta_c  =  params->KCa_Bbeta_c;
   NaR_e  =  params->NaR_e;
   NaR_g  =  params->NaR_g;
   KCa_Abeta_c  =  params->KCa_Abeta_c;
   CaHVA_gbar  =  params->CaHVA_gbar;
   KCa_g  =  params->KCa_g;
   KCa_e  =  params->KCa_e;
   HCN2_rA  =  params->HCN2_rA;
   HCN2_rB  =  params->HCN2_rB;
   SK2_invc1  =  params->SK2_invc1;
   SK2_invc2  =  params->SK2_invc2;
   SK2_invc3  =  params->SK2_invc3;
   KCa_gbar  =  params->KCa_gbar;
   Lkg_erev  =  params->Lkg_erev;
   NaP_Kalpha_m  =  params->NaP_Kalpha_m;
   KA_K_ainf  =  params->KA_K_ainf;
   ca_cai0  =  params->ca_cai0;
   HCN1_erev  =  params->HCN1_erev;
   HCN1_gbar  =  params->HCN1_gbar;
   KV_V0beta_n  =  params->KV_V0beta_n;
   KA_V0beta_b  =  params->KA_V0beta_b;
   KA_V0beta_a  =  params->KA_V0beta_a;
   NaP_g  =  params->NaP_g;
   NaP_e  =  params->NaP_e;
   NaP_B_minf  =  params->NaP_B_minf;
   NaR_erev  =  params->NaR_erev;
   KCa_Aalpha_c  =  params->KCa_Aalpha_c;
   ca2_ca2i0  =  params->ca2_ca2i0;
   NaR_V0beta_s  =  params->NaR_V0beta_s;
   SK2_erev  =  params->SK2_erev;
   comp21_L  =  params->comp21_L;
   KV_Kbeta_n  =  params->KV_Kbeta_n;
   NaR_Aalpha_s  =  params->NaR_Aalpha_s;
   Na_Kbeta_u  =  params->Na_Kbeta_u;
   Na_Kbeta_v  =  params->Na_Kbeta_v;
   KCa_Kalpha_c  =  params->KCa_Kalpha_c;
   comp20_c  =  params->comp20_c;
   CaLVA_valence  =  params->CaLVA_valence;
   NaP_Aalpha_m  =  params->NaP_Aalpha_m;
   HCN2_gbar  =  params->HCN2_gbar;
   KM_erev  =  params->KM_erev;
   ca2_beta  =  params->ca2_beta;
   CaLVA_C_tau_h  =  params->CaLVA_C_tau_h;
   NaP_V0beta_m  =  params->NaP_V0beta_m;
   KV_Kalpha_n  =  params->KV_Kalpha_n;
   HCN2_c  =  params->HCN2_c;
   HCN2_e  =  params->HCN2_e;
   HCN2_g  =  params->HCN2_g;
   NaP_Abeta_m  =  params->NaP_Abeta_m;
   comp19_celsius  =  params->comp19_celsius;
   NaR_V0beta_f  =  params->NaR_V0beta_f;
   CaHVA_Abeta_u  =  params->CaHVA_Abeta_u;
   ca2_d  =  params->ca2_d;
   CaLVA_shift  =  params->CaLVA_shift;
   SK2_g  =  params->SK2_g;
   HCN1_c  =  params->HCN1_c;
   CaLVA_C_tau_m  =  params->CaLVA_C_tau_m;
   CaLVA_A_tau_h  =  params->CaLVA_A_tau_h;
   HCN1_e  =  params->HCN1_e;
   SK2_e  =  params->SK2_e;
   HCN1_g  =  params->HCN1_g;
   CaLVA_A_tau_m  =  params->CaLVA_A_tau_m;
   KV_gbar  =  params->KV_gbar;
   ca2_F  =  params->ca2_F;
   KM_Abeta_n  =  params->KM_Abeta_n;
   NaP_erev  =  params->NaP_erev;
   KM_V0alpha_n  =  params->KM_V0alpha_n;
   HCN2_tEs  =  params->HCN2_tEs;
   CaHVA_V0alpha_s  =  params->CaHVA_V0alpha_s;
   NaP_Kbeta_m  =  params->NaP_Kbeta_m;
   CaHVA_Abeta_s  =  params->CaHVA_Abeta_s;
   CaHVA_V0alpha_u  =  params->CaHVA_V0alpha_u;
   KM_V0_ninf  =  params->KM_V0_ninf;
   Na_Aalpha_u  =  params->Na_Aalpha_u;
   Na_Aalpha_v  =  params->Na_Aalpha_v;
   KA_K_binf  =  params->KA_K_binf;
   NaR_Kbeta_f  =  params->NaR_Kbeta_f;
   NaR_Kbeta_s  =  params->NaR_Kbeta_s;
   CaHVA_R  =  params->CaHVA_R;
   CaHVA_V0beta_u  =  params->CaHVA_V0beta_u;
   CaHVA_V0beta_s  =  params->CaHVA_V0beta_s;
   ca_beta  =  params->ca_beta;
   CaLVA_k_tau_h1  =  params->CaLVA_k_tau_h1;
   CaLVA_k_tau_h2  =  params->CaLVA_k_tau_h2;
   CaHVA_F  =  params->CaHVA_F;
   HCN2_tEf  =  params->HCN2_tEf;
   CaHVA_Kalpha_s  =  params->CaHVA_Kalpha_s;
   CaHVA_Kalpha_u  =  params->CaHVA_Kalpha_u;
   CaLVA_k_tau_m2  =  params->CaLVA_k_tau_m2;
   KV_g  =  params->KV_g;
   CaLVA_k_tau_m1  =  params->CaLVA_k_tau_m1;
   CaHVA_g  =  params->CaHVA_g;
   KV_e  =  params->KV_e;
   KCa_Balpha_c  =  params->KCa_Balpha_c;
   ca_cao  =  params->ca_cao;
   HCN1_tCf  =  params->HCN1_tCf;
   NaR_Shiftbeta_s  =  params->NaR_Shiftbeta_s;
   CaLVA_gbar  =  params->CaLVA_gbar;
   KM_e  =  params->KM_e;
   Na_V0beta_u  =  params->Na_V0beta_u;
   KM_g  =  params->KM_g;
   Na_V0beta_v  =  params->Na_V0beta_v;
   KV_V0alpha_n  =  params->KV_V0alpha_n;
   ca2_valence  =  params->ca2_valence;
   HCN1_tCs  =  params->HCN1_tCs;
   KV_erev  =  params->KV_erev;
   HCN2_tDs  =  params->HCN2_tDs;
   Na_Kalpha_u  =  params->Na_Kalpha_u;
   Na_Kalpha_v  =  params->Na_Kalpha_v;
   HCN1_tDf  =  params->HCN1_tDf;
   KM_Aalpha_n  =  params->KM_Aalpha_n;
   HCN2_tCf  =  params->HCN2_tCf;
   comp21_diam  =  params->comp21_diam;
   Na_Abeta_v  =  params->Na_Abeta_v;
   Na_Abeta_u  =  params->Na_Abeta_u;
   KCa_erev  =  params->KCa_erev;
   SK2_diff  =  params->SK2_diff;
   CaHVA_Kbeta_u  =  params->CaHVA_Kbeta_u;
   CaHVA_Kbeta_s  =  params->CaHVA_Kbeta_s;
   Na_V0alpha_v  =  params->Na_V0alpha_v;
   HCN2_tDf  =  params->HCN2_tDf;

   v  =  Ith(y,0);
   CaHVA_h264  =  Ith(y,1);
   SK2_SK2_zc2  =  Ith(y,2);
   SK2_SK2_zo1  =  Ith(y,3);
   SK2_SK2_zc3  =  Ith(y,4);
   SK2_SK2_zo2  =  Ith(y,5);
   SK2_SK2_zc4  =  Ith(y,6);
   CaHVA_m263  =  Ith(y,7);
   KA_m275  =  Ith(y,8);
   Na_m296  =  Ith(y,9);
   KCa_m281  =  Ith(y,10);
   KA_h276  =  Ith(y,11);
   Na_h297  =  Ith(y,12);
   CaLVA_m269  =  Ith(y,13);
   CaLVA_h270  =  Ith(y,14);
   NaR_m307  =  Ith(y,15);
   NaR_h308  =  Ith(y,16);
   KV_m291  =  Ith(y,17);
   NaP_m302  =  Ith(y,18);
   KM_m286  =  Ith(y,19);
   HCN2_o_fast  =  Ith(y,20);
   HCN1_o_slow  =  Ith(y,21);
   HCN1_o_fast  =  Ith(y,22);
   HCN2_o_slow  =  Ith(y,23);
   ca_ca  =  Ith(y,24);
   ca2_ca2  =  Ith(y,25);
   AMPA_B  =  Ith(y,26);
   AMPA_A  =  Ith(y,27);

   ca2i  =  ca2_ca2;
   CaLVA_ca2i  =  ca2i;
   ca2o  =  ca2_ca2o;
   CaLVA_ca2o  =  ca2o;
   CaLVA_e  =  (1000.0 * CaLVA_R * (comp19_celsius + 273.15)) / (2.0 * CaLVA_F) * log(CaLVA_ca2o / CaLVA_ca2i);
   i_CaLVA  =  (CaLVA_gbar * pow(CaLVA_m269, 2.0) * CaLVA_h270) * (v - CaLVA_e);
   ica2  =  i_CaLVA;
   ca2_ica2  =  ica2;
   cai  =  ca_ca;
   KCa_cai  =  cai;
   SK2_cai  =  cai;
   CaHVA_cai  =  cai;
   cao  =  ca_cao;
   CaHVA_cao  =  cao;
   CaHVA_e  =  (1000.0 * CaHVA_R * (comp19_celsius + 273.15)) / (2.0 * CaHVA_F) * log(CaHVA_cao / CaHVA_cai);
   i_CaHVA  =  (CaHVA_g * pow(CaHVA_m263, 2.0) * CaHVA_h264) * (v - CaHVA_e);
   ica  =  i_CaHVA;
   ca_ica  =  ica;
   NaR_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   HCN1_o_slow_inf  =  (1.0 + -(HCN1_r(v, params))) * (HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params));
   KCa_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   Na_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   CaHVA_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   HCN1_tau_s  =  HCN1_tau(v, HCN1_tCs, HCN1_tDs, HCN1_tEs, params);
   HCN1_tau_f  =  HCN1_tau(v, HCN1_tCf, HCN1_tDf, HCN1_tEf, params);
   HCN1_o_fast_inf  =  HCN1_r(v, params) * HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params);
   NaP_m_inf298  =  1.0 / (1.0 + exp(-(v + -(NaP_V0_minf)) / NaP_B_minf));
   KA_Q10  =  pow(3.0, (comp19_celsius + -25.5) / 10.0);
   CaLVA_m_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_m_inf)) / CaLVA_k_m_inf));
   HCN2_o_slow_inf  =  (1.0 + -(HCN2_r(v, HCN2_rA, HCN2_rB, params))) * (HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params));
   CaLVA_phi_m  =  pow(5.0, (comp19_celsius + -24.0) / 10.0);
   CaLVA_phi_h  =  pow(3.0, (comp19_celsius + -24.0) / 10.0);
   NaP_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   KM_m_inf282  =  1.0 / (1.0 + exp(-(v + -(KM_V0_ninf)) / KM_B_ninf));
   CaLVA_h_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_h_inf)) / CaLVA_k_h_inf));
   HCN2_o_fast_inf  =  HCN2_r(v, HCN2_rA, HCN2_rB, params) * HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params);
   KV_Q10  =  pow(3.0, (comp19_celsius + -6.3) / 10.0);
   SK2_Q10  =  pow(3.0, (comp19_celsius + -23.0) / 10.0);
   HCN2_tau_s  =  HCN2_tau_slow(v, HCN2_tCs, HCN2_tDs, HCN2_tEs, params);
   KM_Q10  =  pow(3.0, (comp19_celsius + -22.0) / 10.0);
   AMPA_g  =  AMPA_B + -(AMPA_A);
   HCN2_tau_f  =  HCN2_tau_fast(v, HCN2_tCf, HCN2_tDf, HCN2_tEf, params);
   KA_a_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_ainf)) / KA_K_ainf));
   KA_b_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_binf)) / KA_K_binf));
   KM_m_tau283  =  1.0 / (KM_alpha_n(v, KM_Q10, params) + KM_beta_n(v, KM_Q10, params));
   CaHVA_tau_s  =  1.0 / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   CaHVA_tau_u  =  1.0 / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   KV_tau_n  =  1.0 / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   CaLVA_h_inf267  =  CaLVA_h_inf;
   KCa_c_inf  =  (KCa_alpha_c(v, KCa_cai, KCa_Q10, params)) / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   Na_v_inf  =  (Na_alpha_v(v, Na_Q10, params)) / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   SK2_dirc3_t  =  SK2_dirc3 * SK2_Q10;
   NaR_tau_s  =  1.0 / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   KA_h_inf273  =  KA_b_inf;
   NaR_tau_f  =  1.0 / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   NaP_m_tau299  =  5.0 / (NaP_alpha_m(v, NaP_Q10, params) + NaP_beta_m(v, NaP_Q10, params));
   KA_tau_b  =  1.0 / (KA_alpha_b(v, KA_Q10, params) + KA_beta_b(v, KA_Q10, params));
   KA_tau_a  =  1.0 / (KA_alpha_a(v, KA_Q10, params) + KA_beta_a(v, KA_Q10, params));
   SK2_dirc2_t  =  SK2_dirc2 * SK2_Q10;
   SK2_invc3_t  =  SK2_invc3 * SK2_Q10;
   SK2_dirc4_t  =  SK2_dirc4 * SK2_Q10;
   SK2_invo1_t  =  SK2_invo1 * SK2_Q10;
   KV_n_inf  =  (KV_alpha_n(v, KV_Q10, params)) / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   KCa_tau_c  =  1.0 / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   CaLVA_tau_h  =  (CaLVA_C_tau_h + CaLVA_A_tau_h / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_h1)) / CaLVA_k_tau_h1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_h2)) / CaLVA_k_tau_h2))) / CaLVA_phi_h;
   CaHVA_u_inf  =  (CaHVA_alpha_u(v, CaHVA_Q10, params)) / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   Na_tau_v  =  1.0 / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   Na_tau_u  =  1.0 / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   CaLVA_tau_m  =  (CaLVA_C_tau_m + CaLVA_A_tau_m / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_m1)) / CaLVA_k_tau_m1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_m2)) / CaLVA_k_tau_m2))) / CaLVA_phi_m;
   NaR_s_inf  =  (NaR_alpha_s(v, NaR_Q10, params)) / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   Na_u_inf  =  (Na_alpha_u(v, Na_Q10, params)) / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   SK2_diro2_t  =  SK2_diro2 * SK2_Q10;
   CaLVA_m_inf265  =  CaLVA_m_inf;
   SK2_invc1_t  =  SK2_invc1 * SK2_Q10;
   SK2_invo2_t  =  SK2_invo2 * SK2_Q10;
   SK2_diro1_t  =  SK2_diro1 * SK2_Q10;
   CaHVA_s_inf  =  (CaHVA_alpha_s(v, CaHVA_Q10, params)) / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   NaR_f_inf  =  (NaR_alpha_f(v, NaR_Q10, params)) / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   SK2_invc2_t  =  SK2_invc2 * SK2_Q10;
   KA_m_inf271  =  KA_a_inf;
   KA_m_tau272  =  KA_tau_a;
   SK2_dirc3_t_ca  =  SK2_dirc3_t * SK2_cai / SK2_diff;
   CaHVA_h_inf261  =  CaHVA_u_inf;
   KV_m_inf287  =  KV_n_inf;
   CaHVA_h_tau262  =  CaHVA_tau_u;
   Na_m_inf292  =  Na_u_inf;
   KCa_m_tau278  =  KCa_tau_c;
   Na_h_tau295  =  Na_tau_v;
   Na_h_inf294  =  Na_v_inf;
   NaR_h_inf305  =  NaR_f_inf;
   NaR_m_inf303  =  NaR_s_inf;
   NaR_h_tau306  =  NaR_tau_f;
   CaHVA_m_tau260  =  CaHVA_tau_s;
   KA_h_tau274  =  KA_tau_b;
   SK2_dirc2_t_ca  =  SK2_dirc2_t * SK2_cai / SK2_diff;
   KV_m_tau288  =  KV_tau_n;
   NaR_m_tau304  =  NaR_tau_s;
   Na_m_tau293  =  Na_tau_u;
   SK2_dirc4_t_ca  =  SK2_dirc4_t * SK2_cai / SK2_diff;
   CaHVA_m_inf259  =  CaHVA_s_inf;
   KCa_m_inf277  =  KCa_c_inf;
   CaLVA_m_tau266  =  CaLVA_tau_m;
   CaLVA_h_tau268  =  CaLVA_tau_h;
   SK2_SK2_z  =  SK2_SK2_zo1 + SK2_SK2_zo2;
   i_AMPA  =  (100.0 / (M_PI * comp21_L * comp21_diam)) * AMPA_g * (v - AMPA_e);
   i_Lkg  =  Lkg_gbar * (v - Lkg_erev);
   i_HCN1  =  (HCN1_gbar * (HCN1_o_slow + HCN1_o_fast)) * (v - HCN1_erev);
   i_HCN2  =  (HCN2_gbar * (HCN2_o_slow + HCN2_o_fast)) * (v - HCN2_erev);
   i  =  i_AMPA + i_Lkg + i_HCN1 + i_HCN2;
   i_NaP  =  (NaP_gbar * NaP_m302) * (v - NaP_erev);
   i_NaR  =  (NaR_gbar * NaR_m307 * NaR_h308) * (v - NaR_erev);
   i_Na  =  (Na_gbar * pow(Na_m296, 3.0) * Na_h297) * (v - Na_erev);
   ina  =  i_NaP + i_NaR + i_Na;
   i_KA  =  (KA_gbar * pow(KA_m275, 3.0) * KA_h276) * (v - KA_erev);
   i_KCa  =  (KCa_gbar * KCa_m281) * (v - KCa_erev);
   i_KM  =  (KM_gbar * KM_m286) * (v - KM_erev);
   i_KV  =  (KV_gbar * pow(KV_m291, 4.0)) * (v - KV_erev);
   i_SK2  =  (SK2_gbar * SK2_SK2_z) * (v - SK2_erev);
   ik  =  i_KA + i_KCa + i_KM + i_KV + i_SK2;

   Ith(f,0)  =  ((node.B_.I_stim_) * 100.0 / (M_PI * comp21_L * comp21_diam) + -1000.0 * (ik + ina + i + ica2 + ica)) / comp20_c;
   Ith(f,1)  =  (CaHVA_h_inf261 + -(CaHVA_h264)) / CaHVA_h_tau262;
   v310  =  SK2_SK2_zo1 + SK2_SK2_zo2 + SK2_SK2_zc4 + SK2_SK2_zc3 + SK2_SK2_zc2;; 
Ith(f,2)  =  -(SK2_SK2_zc2 * SK2_dirc3_t_ca + SK2_SK2_zc2 * SK2_invc1_t) + SK2_SK2_zc3 * SK2_invc2_t + (1.0 - v310) * SK2_dirc2_t_ca;
   Ith(f,3)  =  -(SK2_SK2_zo1 * SK2_invo1_t) + SK2_SK2_zc3 * SK2_diro1_t;
   Ith(f,4)  =  -(SK2_SK2_zc3 * SK2_diro1_t + SK2_SK2_zc3 * SK2_dirc4_t_ca + SK2_SK2_zc3 * SK2_invc2_t) + SK2_SK2_zo1 * SK2_invo1_t + SK2_SK2_zc4 * SK2_invc3_t + SK2_SK2_zc2 * SK2_dirc3_t_ca;
   Ith(f,5)  =  -(SK2_SK2_zo2 * SK2_invo2_t) + SK2_SK2_zc4 * SK2_diro2_t;
   Ith(f,6)  =  -(SK2_SK2_zc4 * SK2_diro2_t + SK2_SK2_zc4 * SK2_invc3_t) + SK2_SK2_zo2 * SK2_invo2_t + SK2_SK2_zc3 * SK2_dirc4_t_ca;
   Ith(f,7)  =  (CaHVA_m_inf259 + -(CaHVA_m263)) / CaHVA_m_tau260;
   Ith(f,8)  =  (KA_m_inf271 + -(KA_m275)) / KA_m_tau272;
   Ith(f,9)  =  (Na_m_inf292 + -(Na_m296)) / Na_m_tau293;
   Ith(f,10)  =  (KCa_m_inf277 + -(KCa_m281)) / KCa_m_tau278;
   Ith(f,11)  =  (KA_h_inf273 + -(KA_h276)) / KA_h_tau274;
   Ith(f,12)  =  (Na_h_inf294 + -(Na_h297)) / Na_h_tau295;
   Ith(f,13)  =  (CaLVA_m_inf265 + -(CaLVA_m269)) / CaLVA_m_tau266;
   Ith(f,14)  =  (CaLVA_h_inf267 + -(CaLVA_h270)) / CaLVA_h_tau268;
   Ith(f,15)  =  (NaR_m_inf303 + -(NaR_m307)) / NaR_m_tau304;
   Ith(f,16)  =  (NaR_h_inf305 + -(NaR_h308)) / NaR_h_tau306;
   Ith(f,17)  =  (KV_m_inf287 + -(KV_m291)) / KV_m_tau288;
   Ith(f,18)  =  (NaP_m_inf298 + -(NaP_m302)) / NaP_m_tau299;
   Ith(f,19)  =  (KM_m_inf282 + -(KM_m286)) / KM_m_tau283;
   Ith(f,20)  =  (HCN2_o_fast_inf + -(HCN2_o_fast)) / HCN2_tau_f;
   Ith(f,21)  =  (HCN1_o_slow_inf + -(HCN1_o_slow)) / HCN1_tau_s;
   Ith(f,22)  =  (HCN1_o_fast_inf + -(HCN1_o_fast)) / HCN1_tau_f;
   Ith(f,23)  =  (HCN2_o_slow_inf + -(HCN2_o_slow)) / HCN2_tau_s;
   Ith(f,24)  =  (-(ca_ica)) / (2.0 * ca_F * ca_d) * 10000.0 + -(ca_beta * (ca_ca + -(ca_cai0)));
   Ith(f,25)  =  (-(ca2_ica2)) / (2.0 * ca2_F * ca2_d) * 10000.0 + -(ca2_beta * (ca2_ca2 + -(ca2_ca2i0)));
   Ith(f,26)  =  -(AMPA_B) / AMPA_tau2;
   Ith(f,27)  =  -(AMPA_A) / AMPA_tau1;

   return GSL_SUCCESS;

}






extern "C" int Golgi_steadystate (const gsl_vector *u, void *pnode, gsl_vector *f)
{
   double ica2, ca2_ica2, ca_ca, cai, KCa_cai, SK2_cai, ca2_ca2, ca2i, CaLVA_ca2i, ca2_ca2o, ca2o, CaLVA_ca2o, ica, ca_ica, ca_cao, cao, CaHVA_cao, CaHVA_cai, comp19_celsius, NaR_Q10, HCN1_c, HCN1_Ehalf, v, HCN1_o_slow_inf, KCa_Q10, Na_Q10, CaHVA_F, CaHVA_R, CaHVA_e, CaHVA_Q10, HCN1_tEs, HCN1_tDs, HCN1_tCs, HCN1_tau_s, HCN1_tEf, HCN1_tDf, HCN1_tCf, HCN1_tau_f, HCN1_o_fast_inf, NaP_B_minf, NaP_V0_minf, NaP_m_inf298, KA_Q10, CaLVA_k_m_inf, CaLVA_v0_m_inf, CaLVA_shift, CaLVA_m_inf, HCN2_c, HCN2_Ehalf, HCN2_rB, HCN2_rA, HCN2_o_slow_inf, CaLVA_phi_m, CaLVA_phi_h, NaP_Q10, KM_B_ninf, KM_V0_ninf, KM_m_inf282, CaLVA_k_h_inf, CaLVA_v0_h_inf, CaLVA_h_inf, HCN2_o_fast_inf, KV_Q10, SK2_Q10, CaLVA_F, CaLVA_R, CaLVA_e, HCN2_tEs, HCN2_tDs, HCN2_tCs, HCN2_tau_s, KM_Q10, AMPA_A, AMPA_B, AMPA_g, HCN2_tEf, HCN2_tDf, HCN2_tCf, HCN2_tau_f, KA_K_ainf, KA_V0_ainf, KA_a_inf, KA_K_binf, KA_V0_binf, KA_b_inf, KM_m_tau283, CaHVA_tau_s, CaHVA_tau_u, KV_tau_n, CaLVA_h_inf267, KCa_c_inf, Na_v_inf, SK2_dirc3, SK2_dirc3_t, NaR_tau_s, KA_h_inf273, NaR_tau_f, NaP_m_tau299, KA_tau_b, KA_tau_a, SK2_dirc2, SK2_dirc2_t, SK2_invc3, SK2_invc3_t, SK2_dirc4, SK2_dirc4_t, SK2_invo1, SK2_invo1_t, KV_n_inf, KCa_tau_c, CaLVA_k_tau_h2, CaLVA_v0_tau_h2, CaLVA_k_tau_h1, CaLVA_v0_tau_h1, CaLVA_A_tau_h, CaLVA_C_tau_h, CaLVA_tau_h, CaHVA_u_inf, Na_tau_v, Na_tau_u, CaLVA_k_tau_m2, CaLVA_v0_tau_m2, CaLVA_k_tau_m1, CaLVA_v0_tau_m1, CaLVA_A_tau_m, CaLVA_C_tau_m, CaLVA_tau_m, NaR_s_inf, Na_u_inf, SK2_diro2, SK2_diro2_t, CaLVA_m_inf265, SK2_invc1, SK2_invc1_t, SK2_invo2, SK2_invo2_t, SK2_diro1, SK2_diro1_t, CaHVA_s_inf, NaR_f_inf, SK2_invc2, SK2_invc2_t, KA_m_inf271, KA_m_tau272, SK2_diff, SK2_dirc3_t_ca, CaHVA_h_inf261, KV_m_inf287, CaHVA_h_tau262, Na_m_inf292, KCa_m_tau278, Na_h_tau295, Na_h_inf294, NaR_h_inf305, NaR_m_inf303, NaR_h_tau306, CaHVA_m_tau260, KA_h_tau274, SK2_dirc2_t_ca, KV_m_tau288, NaR_m_tau304, Na_m_tau293, SK2_dirc4_t_ca, CaHVA_m_inf259, KCa_m_inf277, CaLVA_m_tau266, CaLVA_h_tau268, HCN2_o_fast, HCN1_o_slow, HCN1_o_fast, HCN2_o_slow, NaP_m302, KM_m286, CaHVA_h264, CaHVA_m263, KA_m275, Na_m296, KCa_m281, KA_h276, Na_h297, CaLVA_m269, CaLVA_h270, NaR_m307, NaR_h308, KV_m291, i_AMPA, i_Lkg, i_HCN1, i_HCN2, i, i_CaHVA, i_CaLVA, i_NaP, i_NaR, i_Na, ina, i_KA, i_KCa, i_KM, i_KV, i_SK2, ik, SK2_SK2_zc4, SK2_SK2_zo2, SK2_SK2_zc3, SK2_SK2_zo1, SK2_SK2_zc2, KM_V0beta_n, Na_V0alpha_u, NaR_Shiftalpha_s, AMPA_e, NaR_Aalpha_f, KA_Kalpha_b, KA_Kalpha_a, KCa_Kbeta_c, SK2_gbar, KV_Abeta_n, KM_Kalpha_n, KA_g, KA_e, Lkg_e, Lkg_g, KA_Abeta_b, NaR_V0alpha_f, KA_Abeta_a, NaR_V0alpha_s, CaLVA_g, NaP_V0alpha_m, CaHVA_Aalpha_s, CaHVA_Aalpha_u, HCN2_erev, KA_Kbeta_a, KA_Kbeta_b, Lkg_gbar, KM_gbar, AMPA_scale_factor, Na_gbar, NaP_gbar, ca_d, AMPA_tp, Na_erev, NaR_gbar, AMPA_tau1, AMPA_tau2, ca_F, KA_V0alpha_b, KA_V0alpha_a, KA_Aalpha_b, KA_Aalpha_a, KM_Kbeta_n, KA_gbar, KA_erev, HCN1_rB, HCN1_rA, AMPA_tauA, AMPA_tauB, NaR_Abeta_s, comp19_V_t, NaR_Abeta_f, Na_e, Na_g, NaR_Kalpha_f, NaR_Kalpha_s, KV_Aalpha_n, KCa_Bbeta_c, NaR_e, NaR_g, KCa_Abeta_c, CaHVA_gbar, KCa_g, KCa_e, KCa_gbar, Lkg_erev, NaP_Kalpha_m, ca_cai0, HCN1_erev, HCN1_gbar, KV_V0beta_n, KA_V0beta_b, KA_V0beta_a, NaP_g, NaP_e, NaR_erev, KCa_Aalpha_c, ca2_ca2i0, NaR_V0beta_s, SK2_erev, comp21_L, KV_Kbeta_n, NaR_Aalpha_s, Na_Kbeta_u, Na_Kbeta_v, KCa_Kalpha_c, comp20_c, CaLVA_valence, NaP_Aalpha_m, HCN2_gbar, KM_erev, ca2_beta, NaP_V0beta_m, KV_Kalpha_n, HCN2_e, HCN2_g, NaP_Abeta_m, NaR_V0beta_f, CaHVA_Abeta_u, ca2_d, SK2_g, HCN1_e, SK2_e, HCN1_g, KV_gbar, ca2_F, KM_Abeta_n, NaP_erev, KM_V0alpha_n, CaHVA_V0alpha_s, NaP_Kbeta_m, CaHVA_Abeta_s, CaHVA_V0alpha_u, Na_Aalpha_u, Na_Aalpha_v, NaR_Kbeta_f, NaR_Kbeta_s, CaHVA_V0beta_u, CaHVA_V0beta_s, ca_beta, CaHVA_Kalpha_s, CaHVA_Kalpha_u, KV_g, CaHVA_g, KV_e, KCa_Balpha_c, NaR_Shiftbeta_s, CaLVA_gbar, KM_e, Na_V0beta_u, KM_g, Na_V0beta_v, KV_V0alpha_n, ca2_valence, KV_erev, Na_Kalpha_u, Na_Kalpha_v, KM_Aalpha_n, comp21_diam, Na_Abeta_v, Na_Abeta_u, KCa_erev, CaHVA_Kbeta_u, CaHVA_Kbeta_s, Na_V0alpha_v, SK2_SK2_z;

   // params is a reference to the model parameters
   const struct Golgi::Parameters_ *params = (struct Golgi::Parameters_ *)pnode;

   KM_V0beta_n  =  params->KM_V0beta_n;
   Na_V0alpha_u  =  params->Na_V0alpha_u;
   NaR_Shiftalpha_s  =  params->NaR_Shiftalpha_s;
   AMPA_e  =  params->AMPA_e;
   NaR_Aalpha_f  =  params->NaR_Aalpha_f;
   CaLVA_k_m_inf  =  params->CaLVA_k_m_inf;
   KA_Kalpha_b  =  params->KA_Kalpha_b;
   KA_Kalpha_a  =  params->KA_Kalpha_a;
   KCa_Kbeta_c  =  params->KCa_Kbeta_c;
   SK2_invo1  =  params->SK2_invo1;
   SK2_invo2  =  params->SK2_invo2;
   SK2_gbar  =  params->SK2_gbar;
   KV_Abeta_n  =  params->KV_Abeta_n;
   KM_Kalpha_n  =  params->KM_Kalpha_n;
   KA_g  =  params->KA_g;
   KA_e  =  params->KA_e;
   Lkg_e  =  params->Lkg_e;
   Lkg_g  =  params->Lkg_g;
   HCN1_tEf  =  params->HCN1_tEf;
   KA_Abeta_b  =  params->KA_Abeta_b;
   NaR_V0alpha_f  =  params->NaR_V0alpha_f;
   KA_Abeta_a  =  params->KA_Abeta_a;
   NaR_V0alpha_s  =  params->NaR_V0alpha_s;
   CaLVA_F  =  params->CaLVA_F;
   HCN1_tEs  =  params->HCN1_tEs;
   KM_B_ninf  =  params->KM_B_ninf;
   CaLVA_R  =  params->CaLVA_R;
   HCN1_tDs  =  params->HCN1_tDs;
   CaLVA_g  =  params->CaLVA_g;
   NaP_V0alpha_m  =  params->NaP_V0alpha_m;
   SK2_diro1  =  params->SK2_diro1;
   CaHVA_Aalpha_s  =  params->CaHVA_Aalpha_s;
   CaHVA_Aalpha_u  =  params->CaHVA_Aalpha_u;
   SK2_diro2  =  params->SK2_diro2;
   HCN2_erev  =  params->HCN2_erev;
   HCN1_Ehalf  =  params->HCN1_Ehalf;
   KA_V0_binf  =  params->KA_V0_binf;
   KA_Kbeta_a  =  params->KA_Kbeta_a;
   KA_Kbeta_b  =  params->KA_Kbeta_b;
   Lkg_gbar  =  params->Lkg_gbar;
   KM_gbar  =  params->KM_gbar;
   AMPA_scale_factor  =  params->AMPA_scale_factor;
   Na_gbar  =  params->Na_gbar;
   CaLVA_v0_m_inf  =  params->CaLVA_v0_m_inf;
   NaP_gbar  =  params->NaP_gbar;
   ca_d  =  params->ca_d;
   AMPA_tp  =  params->AMPA_tp;
   HCN2_tCs  =  params->HCN2_tCs;
   CaLVA_k_h_inf  =  params->CaLVA_k_h_inf;
   Na_erev  =  params->Na_erev;
   NaP_V0_minf  =  params->NaP_V0_minf;
   NaR_gbar  =  params->NaR_gbar;
   AMPA_tau1  =  params->AMPA_tau1;
   AMPA_tau2  =  params->AMPA_tau2;
   ca_F  =  params->ca_F;
   KA_V0alpha_b  =  params->KA_V0alpha_b;
   KA_V0alpha_a  =  params->KA_V0alpha_a;
   KA_Aalpha_b  =  params->KA_Aalpha_b;
   KA_Aalpha_a  =  params->KA_Aalpha_a;
   KM_Kbeta_n  =  params->KM_Kbeta_n;
   CaLVA_v0_tau_m1  =  params->CaLVA_v0_tau_m1;
   CaLVA_v0_tau_m2  =  params->CaLVA_v0_tau_m2;
   KA_gbar  =  params->KA_gbar;
   KA_erev  =  params->KA_erev;
   HCN1_rB  =  params->HCN1_rB;
   HCN1_rA  =  params->HCN1_rA;
   KA_V0_ainf  =  params->KA_V0_ainf;
   AMPA_tauA  =  params->AMPA_tauA;
   AMPA_tauB  =  params->AMPA_tauB;
   CaLVA_v0_tau_h2  =  params->CaLVA_v0_tau_h2;
   CaLVA_v0_tau_h1  =  params->CaLVA_v0_tau_h1;
   NaR_Abeta_s  =  params->NaR_Abeta_s;
   comp19_V_t  =  params->comp19_V_t;
   HCN2_Ehalf  =  params->HCN2_Ehalf;
   CaLVA_v0_h_inf  =  params->CaLVA_v0_h_inf;
   NaR_Abeta_f  =  params->NaR_Abeta_f;
   ca2_ca2o  =  params->ca2_ca2o;
   Na_e  =  params->Na_e;
   Na_g  =  params->Na_g;
   NaR_Kalpha_f  =  params->NaR_Kalpha_f;
   SK2_dirc4  =  params->SK2_dirc4;
   SK2_dirc3  =  params->SK2_dirc3;
   SK2_dirc2  =  params->SK2_dirc2;
   NaR_Kalpha_s  =  params->NaR_Kalpha_s;
   KV_Aalpha_n  =  params->KV_Aalpha_n;
   KCa_Bbeta_c  =  params->KCa_Bbeta_c;
   NaR_e  =  params->NaR_e;
   NaR_g  =  params->NaR_g;
   KCa_Abeta_c  =  params->KCa_Abeta_c;
   CaHVA_gbar  =  params->CaHVA_gbar;
   KCa_g  =  params->KCa_g;
   KCa_e  =  params->KCa_e;
   HCN2_rA  =  params->HCN2_rA;
   HCN2_rB  =  params->HCN2_rB;
   SK2_invc1  =  params->SK2_invc1;
   SK2_invc2  =  params->SK2_invc2;
   SK2_invc3  =  params->SK2_invc3;
   KCa_gbar  =  params->KCa_gbar;
   Lkg_erev  =  params->Lkg_erev;
   NaP_Kalpha_m  =  params->NaP_Kalpha_m;
   KA_K_ainf  =  params->KA_K_ainf;
   ca_cai0  =  params->ca_cai0;
   HCN1_erev  =  params->HCN1_erev;
   HCN1_gbar  =  params->HCN1_gbar;
   KV_V0beta_n  =  params->KV_V0beta_n;
   KA_V0beta_b  =  params->KA_V0beta_b;
   KA_V0beta_a  =  params->KA_V0beta_a;
   NaP_g  =  params->NaP_g;
   NaP_e  =  params->NaP_e;
   NaP_B_minf  =  params->NaP_B_minf;
   NaR_erev  =  params->NaR_erev;
   KCa_Aalpha_c  =  params->KCa_Aalpha_c;
   ca2_ca2i0  =  params->ca2_ca2i0;
   NaR_V0beta_s  =  params->NaR_V0beta_s;
   SK2_erev  =  params->SK2_erev;
   comp21_L  =  params->comp21_L;
   KV_Kbeta_n  =  params->KV_Kbeta_n;
   NaR_Aalpha_s  =  params->NaR_Aalpha_s;
   Na_Kbeta_u  =  params->Na_Kbeta_u;
   Na_Kbeta_v  =  params->Na_Kbeta_v;
   KCa_Kalpha_c  =  params->KCa_Kalpha_c;
   comp20_c  =  params->comp20_c;
   CaLVA_valence  =  params->CaLVA_valence;
   NaP_Aalpha_m  =  params->NaP_Aalpha_m;
   HCN2_gbar  =  params->HCN2_gbar;
   KM_erev  =  params->KM_erev;
   ca2_beta  =  params->ca2_beta;
   CaLVA_C_tau_h  =  params->CaLVA_C_tau_h;
   NaP_V0beta_m  =  params->NaP_V0beta_m;
   KV_Kalpha_n  =  params->KV_Kalpha_n;
   HCN2_c  =  params->HCN2_c;
   HCN2_e  =  params->HCN2_e;
   HCN2_g  =  params->HCN2_g;
   NaP_Abeta_m  =  params->NaP_Abeta_m;
   comp19_celsius  =  params->comp19_celsius;
   NaR_V0beta_f  =  params->NaR_V0beta_f;
   CaHVA_Abeta_u  =  params->CaHVA_Abeta_u;
   ca2_d  =  params->ca2_d;
   CaLVA_shift  =  params->CaLVA_shift;
   SK2_g  =  params->SK2_g;
   HCN1_c  =  params->HCN1_c;
   CaLVA_C_tau_m  =  params->CaLVA_C_tau_m;
   CaLVA_A_tau_h  =  params->CaLVA_A_tau_h;
   HCN1_e  =  params->HCN1_e;
   SK2_e  =  params->SK2_e;
   HCN1_g  =  params->HCN1_g;
   CaLVA_A_tau_m  =  params->CaLVA_A_tau_m;
   KV_gbar  =  params->KV_gbar;
   ca2_F  =  params->ca2_F;
   KM_Abeta_n  =  params->KM_Abeta_n;
   NaP_erev  =  params->NaP_erev;
   KM_V0alpha_n  =  params->KM_V0alpha_n;
   HCN2_tEs  =  params->HCN2_tEs;
   CaHVA_V0alpha_s  =  params->CaHVA_V0alpha_s;
   NaP_Kbeta_m  =  params->NaP_Kbeta_m;
   CaHVA_Abeta_s  =  params->CaHVA_Abeta_s;
   CaHVA_V0alpha_u  =  params->CaHVA_V0alpha_u;
   KM_V0_ninf  =  params->KM_V0_ninf;
   Na_Aalpha_u  =  params->Na_Aalpha_u;
   Na_Aalpha_v  =  params->Na_Aalpha_v;
   KA_K_binf  =  params->KA_K_binf;
   NaR_Kbeta_f  =  params->NaR_Kbeta_f;
   NaR_Kbeta_s  =  params->NaR_Kbeta_s;
   CaHVA_R  =  params->CaHVA_R;
   CaHVA_V0beta_u  =  params->CaHVA_V0beta_u;
   CaHVA_V0beta_s  =  params->CaHVA_V0beta_s;
   ca_beta  =  params->ca_beta;
   CaLVA_k_tau_h1  =  params->CaLVA_k_tau_h1;
   CaLVA_k_tau_h2  =  params->CaLVA_k_tau_h2;
   CaHVA_F  =  params->CaHVA_F;
   HCN2_tEf  =  params->HCN2_tEf;
   CaHVA_Kalpha_s  =  params->CaHVA_Kalpha_s;
   CaHVA_Kalpha_u  =  params->CaHVA_Kalpha_u;
   CaLVA_k_tau_m2  =  params->CaLVA_k_tau_m2;
   KV_g  =  params->KV_g;
   CaLVA_k_tau_m1  =  params->CaLVA_k_tau_m1;
   CaHVA_g  =  params->CaHVA_g;
   KV_e  =  params->KV_e;
   KCa_Balpha_c  =  params->KCa_Balpha_c;
   ca_cao  =  params->ca_cao;
   HCN1_tCf  =  params->HCN1_tCf;
   NaR_Shiftbeta_s  =  params->NaR_Shiftbeta_s;
   CaLVA_gbar  =  params->CaLVA_gbar;
   KM_e  =  params->KM_e;
   Na_V0beta_u  =  params->Na_V0beta_u;
   KM_g  =  params->KM_g;
   Na_V0beta_v  =  params->Na_V0beta_v;
   KV_V0alpha_n  =  params->KV_V0alpha_n;
   ca2_valence  =  params->ca2_valence;
   HCN1_tCs  =  params->HCN1_tCs;
   KV_erev  =  params->KV_erev;
   HCN2_tDs  =  params->HCN2_tDs;
   Na_Kalpha_u  =  params->Na_Kalpha_u;
   Na_Kalpha_v  =  params->Na_Kalpha_v;
   HCN1_tDf  =  params->HCN1_tDf;
   KM_Aalpha_n  =  params->KM_Aalpha_n;
   HCN2_tCf  =  params->HCN2_tCf;
   comp21_diam  =  params->comp21_diam;
   Na_Abeta_v  =  params->Na_Abeta_v;
   Na_Abeta_u  =  params->Na_Abeta_u;
   KCa_erev  =  params->KCa_erev;
   SK2_diff  =  params->SK2_diff;
   CaHVA_Kbeta_u  =  params->CaHVA_Kbeta_u;
   CaHVA_Kbeta_s  =  params->CaHVA_Kbeta_s;
   Na_V0alpha_v  =  params->Na_V0alpha_v;
   HCN2_tDf  =  params->HCN2_tDf;


   SK2_SK2_zc2  =  gsl_vector_get (u, 0);
   SK2_SK2_zo1  =  gsl_vector_get (u, 1);
   SK2_SK2_zc3  =  gsl_vector_get (u, 2);
   SK2_SK2_zo2  =  gsl_vector_get (u, 3);
   SK2_SK2_zc4  =  gsl_vector_get (u, 4);

   i_AMPA  =  0.0;
   i_Lkg  =  0.0;
   i_HCN1  =  0.0;
   i_HCN2  =  0.0;
   i  =  0.0;
   i_CaHVA  =  0.0;
   ica  =  0.0;
   i_CaLVA  =  0.0;
   ica2  =  0.0;
   i_NaP  =  0.0;
   i_NaR  =  0.0;
   i_Na  =  0.0;
   ina  =  0.0;
   i_KA  =  0.0;
   i_KCa  =  0.0;
   i_KM  =  0.0;
   i_KV  =  0.0;
   i_SK2  =  0.0;
   ik  =  0.0;

   ca2_ica2  =  ica2;
   ca_ca  =  5e-05;
   cai  =  ca_ca;
   KCa_cai  =  cai;
   SK2_cai  =  cai;
   ca2_ca2  =  5e-05;
   ca2i  =  ca2_ca2;
   CaLVA_ca2i  =  ca2i;
   ca2o  =  ca2_ca2o;
   CaLVA_ca2o  =  ca2o;
   ca_ica  =  ica;
   cao  =  ca_cao;
   CaHVA_cao  =  cao;
   CaHVA_cai  =  cai;
   NaR_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   v  =  -65.0;
   HCN1_o_slow_inf  =  (1.0 + -(HCN1_r(v, params))) * (HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params));
   KCa_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   Na_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   CaHVA_e  =  (1000.0 * CaHVA_R * (comp19_celsius + 273.15)) / (2.0 * CaHVA_F) * log(CaHVA_cao / CaHVA_cai);
   CaHVA_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   HCN1_tau_s  =  HCN1_tau(v, HCN1_tCs, HCN1_tDs, HCN1_tEs, params);
   HCN1_tau_f  =  HCN1_tau(v, HCN1_tCf, HCN1_tDf, HCN1_tEf, params);
   HCN1_o_fast_inf  =  HCN1_r(v, params) * HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params);
   NaP_m_inf298  =  1.0 / (1.0 + exp(-(v + -(NaP_V0_minf)) / NaP_B_minf));
   KA_Q10  =  pow(3.0, (comp19_celsius + -25.5) / 10.0);
   CaLVA_m_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_m_inf)) / CaLVA_k_m_inf));
   HCN2_o_slow_inf  =  (1.0 + -(HCN2_r(v, HCN2_rA, HCN2_rB, params))) * (HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params));
   CaLVA_phi_m  =  pow(5.0, (comp19_celsius + -24.0) / 10.0);
   CaLVA_phi_h  =  pow(3.0, (comp19_celsius + -24.0) / 10.0);
   NaP_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   KM_m_inf282  =  1.0 / (1.0 + exp(-(v + -(KM_V0_ninf)) / KM_B_ninf));
   CaLVA_h_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_h_inf)) / CaLVA_k_h_inf));
   HCN2_o_fast_inf  =  HCN2_r(v, HCN2_rA, HCN2_rB, params) * HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params);
   KV_Q10  =  pow(3.0, (comp19_celsius + -6.3) / 10.0);
   SK2_Q10  =  pow(3.0, (comp19_celsius + -23.0) / 10.0);
   CaLVA_e  =  (1000.0 * CaLVA_R * (comp19_celsius + 273.15)) / (2.0 * CaLVA_F) * log(CaLVA_ca2o / CaLVA_ca2i);
   HCN2_tau_s  =  HCN2_tau_slow(v, HCN2_tCs, HCN2_tDs, HCN2_tEs, params);
   KM_Q10  =  pow(3.0, (comp19_celsius + -22.0) / 10.0);
   AMPA_A  =  0.0;
   AMPA_B  =  0.0;
   AMPA_g  =  AMPA_B + -(AMPA_A);
   HCN2_tau_f  =  HCN2_tau_fast(v, HCN2_tCf, HCN2_tDf, HCN2_tEf, params);
   KA_a_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_ainf)) / KA_K_ainf));
   KA_b_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_binf)) / KA_K_binf));
   KM_m_tau283  =  1.0 / (KM_alpha_n(v, KM_Q10, params) + KM_beta_n(v, KM_Q10, params));
   CaHVA_tau_s  =  1.0 / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   CaHVA_tau_u  =  1.0 / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   KV_tau_n  =  1.0 / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   CaLVA_h_inf267  =  CaLVA_h_inf;
   KCa_c_inf  =  (KCa_alpha_c(v, KCa_cai, KCa_Q10, params)) / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   Na_v_inf  =  (Na_alpha_v(v, Na_Q10, params)) / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   SK2_dirc3_t  =  SK2_dirc3 * SK2_Q10;
   NaR_tau_s  =  1.0 / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   KA_h_inf273  =  KA_b_inf;
   NaR_tau_f  =  1.0 / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   NaP_m_tau299  =  5.0 / (NaP_alpha_m(v, NaP_Q10, params) + NaP_beta_m(v, NaP_Q10, params));
   KA_tau_b  =  1.0 / (KA_alpha_b(v, KA_Q10, params) + KA_beta_b(v, KA_Q10, params));
   KA_tau_a  =  1.0 / (KA_alpha_a(v, KA_Q10, params) + KA_beta_a(v, KA_Q10, params));
   SK2_dirc2_t  =  SK2_dirc2 * SK2_Q10;
   SK2_invc3_t  =  SK2_invc3 * SK2_Q10;
   SK2_dirc4_t  =  SK2_dirc4 * SK2_Q10;
   SK2_invo1_t  =  SK2_invo1 * SK2_Q10;
   KV_n_inf  =  (KV_alpha_n(v, KV_Q10, params)) / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   KCa_tau_c  =  1.0 / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   CaLVA_tau_h  =  (CaLVA_C_tau_h + CaLVA_A_tau_h / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_h1)) / CaLVA_k_tau_h1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_h2)) / CaLVA_k_tau_h2))) / CaLVA_phi_h;
   CaHVA_u_inf  =  (CaHVA_alpha_u(v, CaHVA_Q10, params)) / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   Na_tau_v  =  1.0 / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   Na_tau_u  =  1.0 / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   CaLVA_tau_m  =  (CaLVA_C_tau_m + CaLVA_A_tau_m / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_m1)) / CaLVA_k_tau_m1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_m2)) / CaLVA_k_tau_m2))) / CaLVA_phi_m;
   NaR_s_inf  =  (NaR_alpha_s(v, NaR_Q10, params)) / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   Na_u_inf  =  (Na_alpha_u(v, Na_Q10, params)) / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   SK2_diro2_t  =  SK2_diro2 * SK2_Q10;
   CaLVA_m_inf265  =  CaLVA_m_inf;
   SK2_invc1_t  =  SK2_invc1 * SK2_Q10;
   SK2_invo2_t  =  SK2_invo2 * SK2_Q10;
   SK2_diro1_t  =  SK2_diro1 * SK2_Q10;
   CaHVA_s_inf  =  (CaHVA_alpha_s(v, CaHVA_Q10, params)) / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   NaR_f_inf  =  (NaR_alpha_f(v, NaR_Q10, params)) / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   SK2_invc2_t  =  SK2_invc2 * SK2_Q10;
   KA_m_inf271  =  KA_a_inf;
   KA_m_tau272  =  KA_tau_a;
   SK2_dirc3_t_ca  =  SK2_dirc3_t * SK2_cai / SK2_diff;
   CaHVA_h_inf261  =  CaHVA_u_inf;
   KV_m_inf287  =  KV_n_inf;
   CaHVA_h_tau262  =  CaHVA_tau_u;
   Na_m_inf292  =  Na_u_inf;
   KCa_m_tau278  =  KCa_tau_c;
   Na_h_tau295  =  Na_tau_v;
   Na_h_inf294  =  Na_v_inf;
   NaR_h_inf305  =  NaR_f_inf;
   NaR_m_inf303  =  NaR_s_inf;
   NaR_h_tau306  =  NaR_tau_f;
   CaHVA_m_tau260  =  CaHVA_tau_s;
   KA_h_tau274  =  KA_tau_b;
   SK2_dirc2_t_ca  =  SK2_dirc2_t * SK2_cai / SK2_diff;
   KV_m_tau288  =  KV_tau_n;
   NaR_m_tau304  =  NaR_tau_s;
   Na_m_tau293  =  Na_tau_u;
   SK2_dirc4_t_ca  =  SK2_dirc4_t * SK2_cai / SK2_diff;
   CaHVA_m_inf259  =  CaHVA_s_inf;
   KCa_m_inf277  =  KCa_c_inf;
   CaLVA_m_tau266  =  CaLVA_tau_m;
   CaLVA_h_tau268  =  CaLVA_tau_h;
   HCN2_o_fast  =  HCN2_o_fast_inf;
   HCN1_o_slow  =  HCN1_o_slow_inf;
   HCN1_o_fast  =  HCN1_o_fast_inf;
   HCN2_o_slow  =  HCN2_o_slow_inf;
   NaP_m302  =  1.0 / (1.0 + exp(-(v + -(NaP_V0_minf)) / NaP_B_minf));
   KM_m286  =  1.0 / (1.0 + exp(-(v + -(KM_V0_ninf)) / KM_B_ninf));
   CaHVA_h264  =  CaHVA_u_inf;
   CaHVA_m263  =  CaHVA_s_inf;
   KA_m275  =  KA_a_inf;
   Na_m296  =  Na_u_inf;
   KCa_m281  =  KCa_c_inf;
   KA_h276  =  KA_b_inf;
   Na_h297  =  Na_v_inf;
   CaLVA_m269  =  CaLVA_m_inf;
   CaLVA_h270  =  CaLVA_h_inf;
   NaR_m307  =  NaR_s_inf;
   NaR_h308  =  NaR_f_inf;
   KV_m291  =  KV_n_inf;

   double t315, v310;


   v310  =  SK2_SK2_zo1 + SK2_SK2_zo2 + SK2_SK2_zc4 + SK2_SK2_zc3 + SK2_SK2_zc2;; 
t315  =  -(SK2_SK2_zc2 * SK2_dirc3_t_ca + SK2_SK2_zc2 * SK2_invc1_t) + SK2_SK2_zc3 * SK2_invc2_t + (1.0 - v310) * SK2_dirc2_t_ca;
   gsl_vector_set (f,0,t315);

   double t314;


   t314  =  -(SK2_SK2_zo1 * SK2_invo1_t) + SK2_SK2_zc3 * SK2_diro1_t;
   gsl_vector_set (f,1,t314);

   double t313;


   t313  =  -(SK2_SK2_zc3 * SK2_diro1_t + SK2_SK2_zc3 * SK2_dirc4_t_ca + SK2_SK2_zc3 * SK2_invc2_t) + SK2_SK2_zo1 * SK2_invo1_t + SK2_SK2_zc4 * SK2_invc3_t + SK2_SK2_zc2 * SK2_dirc3_t_ca;
   gsl_vector_set (f,2,t313);

   double t312;


   t312  =  -(SK2_SK2_zo2 * SK2_invo2_t) + SK2_SK2_zc4 * SK2_diro2_t;
   gsl_vector_set (f,3,t312);

   double t311;


   t311  =  -(SK2_SK2_zc4 * SK2_diro2_t + SK2_SK2_zc4 * SK2_invc3_t) + SK2_SK2_zo2 * SK2_invo2_t + SK2_SK2_zc3 * SK2_dirc4_t_ca;
   gsl_vector_set (f,4,t311);


   return 0;
}


// Diagonal Jacobian approximation: (f(s+.01) - f(s))/.001 

// GSL:
// int (* jacobian) (double t, const double y[], double * dfdy, double dfdt[], void * params);


extern "C" int Golgi_jacobian (double t, const double y[], double *dfdy, double dfdt[], void* pnode)
{
   // cast the node ptr to an object of the proper type
   assert(pnode);
   const Golgi & node = *(reinterpret_cast<Golgi*>(pnode));
   Golgi & vnode =  *(reinterpret_cast<Golgi*>(pnode));

   // state is a reference to the model state
   struct Golgi::Buffers_ *b;
   b = &(vnode.B_);

   for (int i = 0; i < b->N; i++) 
   {
       b->u[i] = y[i] + 0.01;
   }

   Golgi_dynamics(t, b->u, b->jac, pnode);
   for (int i = 0; i < b->N; i++) 
   {
       dfdt[i*b->N + i] = (b->jac[i] - dfdy[i]) / .001;
   }
   return 0;

}




Golgi::Parameters_::Parameters_ ():
      

  KM_V0beta_n  (-30.0),

  Na_V0alpha_u  (-25.0),

  NaR_Shiftalpha_s  (8e-05),

  AMPA_e  (0.0),

  NaR_Aalpha_f  (0.31836),

  CaLVA_k_m_inf  (-7.4),

  KA_Kalpha_b  (12.8433),

  KA_Kalpha_a  (-23.32708),

  KCa_Kbeta_c  (-11.765),

  SK2_invo1  (1.0),

  SK2_invo2  (0.1),

  SK2_gbar  (0.038),

  KV_Abeta_n  (0.125),

  KM_Kalpha_n  (40.0),

  KA_g  (0.008),

  KA_e  (-84.69),

  Lkg_e  (-55.0),

  Lkg_g  (2.1e-05),

  HCN1_tEf  (2.302585092),

  KA_Abeta_b  (0.0345),

  NaR_V0alpha_f  (-80.0),

  KA_Abeta_a  (0.1655),

  NaR_V0alpha_s  (-4.48754),

  CaLVA_F  (96485.3),

  HCN1_tEs  (2.302585092),

  KM_B_ninf  (6.0),

  CaLVA_R  (8.31342),

  HCN1_tDs  (-4.056),

  CaLVA_g  (0.00025),

  NaP_V0alpha_m  (-40.0),

  SK2_diro1  (0.16),

  CaHVA_Aalpha_s  (0.04944),

  CaHVA_Aalpha_u  (0.0013),

  SK2_diro2  (1.2),

  HCN2_erev  (-20.0),

  HCN1_Ehalf  (-72.49),

  KA_V0_binf  (-78.8),

  KA_Kbeta_a  (19.47175),

  KA_Kbeta_b  (-8.90123),

  Lkg_gbar  (2.1e-05),

  KM_gbar  (0.001),

  AMPA_scale_factor  (1.27309992372272),

  Na_gbar  (0.048),

  CaLVA_v0_m_inf  (-50.0),

  NaP_gbar  (0.00019),

  ca_d  (0.2),

  AMPA_tp  (0.0897897037263841),

  HCN2_tCs  (0.0152),

  CaLVA_k_h_inf  (5.0),

  Na_erev  (87.39),

  NaP_V0_minf  (-43.0),

  NaR_gbar  (0.0017),

  AMPA_tau1  (0.03),

  AMPA_tau2  (0.5),

  ca_F  (96485.3),

  KA_V0alpha_b  (-111.33209),

  KA_V0alpha_a  (-9.17203),

  KA_Aalpha_b  (0.0368),

  KA_Aalpha_a  (0.8147),

  KM_Kbeta_n  (-20.0),

  CaLVA_v0_tau_m1  (-25.0),

  CaLVA_v0_tau_m2  (-100.0),

  KA_gbar  (0.008),

  KA_erev  (-84.69),

  HCN1_rB  (0.97596),

  HCN1_rA  (0.002096),

  KA_V0_ainf  (-38.0),

  AMPA_tauA  (0.03),

  AMPA_tauB  (0.5),

  CaLVA_v0_tau_h2  (-405.0),

  CaLVA_v0_tau_h1  (-46.0),

  NaR_Abeta_s  (0.01558),

  comp19_V_t  (-35.0),

  HCN2_Ehalf  (-81.95),

  CaLVA_v0_h_inf  (-78.0),

  NaR_Abeta_f  (0.01014),

  ca2_ca2o  (2.0),

  Na_e  (87.39),

  Na_g  (0.048),

  NaR_Kalpha_f  (-62.52621),

  SK2_dirc4  (80.0),

  SK2_dirc3  (160.0),

  SK2_dirc2  (200.0),

  NaR_Kalpha_s  (-6.81881),

  KV_Aalpha_n  (-0.01),

  KCa_Bbeta_c  (0.00015),

  NaR_e  (87.39),

  NaR_g  (0.0017),

  KCa_Abeta_c  (1.0),

  CaHVA_gbar  (0.00046),

  KCa_g  (0.003),

  KCa_e  (-84.69),

  HCN2_rA  (-0.0227),

  HCN2_rB  (-1.4694),

  SK2_invc1  (0.08),

  SK2_invc2  (0.08),

  SK2_invc3  (0.2),

  KCa_gbar  (0.003),

  Lkg_erev  (-55.0),

  NaP_Kalpha_m  (-5.0),

  KA_K_ainf  (-17.0),

  ca_cai0  (5e-05),

  HCN1_erev  (-20.0),

  HCN1_gbar  (5e-05),

  KV_V0beta_n  (-36.0),

  KA_V0beta_b  (-49.9537),

  KA_V0beta_a  (-18.27914),

  NaP_g  (0.00019),

  NaP_e  (87.39),

  NaP_B_minf  (5.0),

  NaR_erev  (87.39),

  KCa_Aalpha_c  (7.0),

  ca2_ca2i0  (5e-05),

  NaR_V0beta_s  (43.97494),

  SK2_erev  (-84.69),

  comp21_L  (27.0),

  KV_Kbeta_n  (-80.0),

  NaR_Aalpha_s  (-0.00493),

  Na_Kbeta_u  (-18.182),

  Na_Kbeta_v  (-5.0),

  KCa_Kalpha_c  (-11.765),

  comp20_c  (1.0),

  CaLVA_valence  (2.0),

  NaP_Aalpha_m  (-0.91),

  HCN2_gbar  (8e-05),

  KM_erev  (-84.69),

  ca2_beta  (1.3),

  CaLVA_C_tau_h  (85.0),

  NaP_V0beta_m  (-40.0),

  KV_Kalpha_n  (-10.0),

  HCN2_c  (0.1661),

  HCN2_e  (-20.0),

  HCN2_g  (8e-05),

  NaP_Abeta_m  (0.62),

  comp19_celsius  (23.0),

  NaR_V0beta_f  (-83.3332),

  CaHVA_Abeta_u  (0.0013),

  ca2_d  (0.2),

  CaLVA_shift  (2.0),

  SK2_g  (0.038),

  HCN1_c  (0.11305),

  CaLVA_C_tau_m  (3.0),

  CaLVA_A_tau_h  (1.0),

  HCN1_e  (-20.0),

  SK2_e  (-84.69),

  HCN1_g  (5e-05),

  CaLVA_A_tau_m  (1.0),

  KV_gbar  (0.032),

  ca2_F  (96485.3),

  KM_Abeta_n  (0.0033),

  NaP_erev  (87.39),

  KM_V0alpha_n  (-30.0),

  HCN2_tEs  (2.3026),

  CaHVA_V0alpha_s  (-29.06),

  NaP_Kbeta_m  (5.0),

  CaHVA_Abeta_s  (0.08298),

  CaHVA_V0alpha_u  (-48.0),

  KM_V0_ninf  (-35.0),

  Na_Aalpha_u  (0.3),

  Na_Aalpha_v  (0.21),

  KA_K_binf  (8.4),

  NaR_Kbeta_f  (16.05379),

  NaR_Kbeta_s  (0.10818),

  CaHVA_R  (8.31342),

  CaHVA_V0beta_u  (-48.0),

  CaHVA_V0beta_s  (-18.66),

  ca_beta  (1.3),

  CaLVA_k_tau_h1  (4.0),

  CaLVA_k_tau_h2  (-50.0),

  CaHVA_F  (96485.3),

  HCN2_tEf  (2.3026),

  CaHVA_Kalpha_s  (15.87301587302),

  CaHVA_Kalpha_u  (-18.183),

  CaLVA_k_tau_m2  (-15.0),

  KV_g  (0.032),

  CaLVA_k_tau_m1  (10.0),

  CaHVA_g  (0.00046),

  KV_e  (-84.69),

  KCa_Balpha_c  (0.0015),

  ca_cao  (2.0),

  HCN1_tCf  (0.01371),

  NaR_Shiftbeta_s  (0.04752),

  CaLVA_gbar  (0.00025),

  KM_e  (-84.69),

  Na_V0beta_u  (-50.0),

  KM_g  (0.001),

  Na_V0beta_v  (-17.0),

  KV_V0alpha_n  (-26.0),

  ca2_valence  (2.0),

  HCN1_tCs  (0.01451),

  KV_erev  (-84.69),

  HCN2_tDs  (-5.2944),

  Na_Kalpha_u  (-10.0),

  Na_Kalpha_v  (-3.333),

  HCN1_tDf  (-3.368),

  KM_Aalpha_n  (0.0033),

  HCN2_tCf  (0.0269),

  comp21_diam  (27.0),

  Na_Abeta_v  (3.0),

  Na_Abeta_u  (12.0),

  KCa_erev  (-84.69),

  SK2_diff  (3.0),

  CaHVA_Kbeta_u  (83.33),

  CaHVA_Kbeta_s  (-25.641),

  Na_V0alpha_v  (-50.0),

  HCN2_tDf  (-5.6111)
  {
  celsius  =  comp19_celsius;
  V_t  =  comp19_V_t;
  }

Golgi::State_::State_ (const Parameters_& p)
{

   double ica2, ca2_ica2, ca_ca, cai, KCa_cai, SK2_cai, ca2_ca2, ca2i, CaLVA_ca2i, ca2_ca2o, ca2o, CaLVA_ca2o, ica, ca_ica, ca_cao, cao, CaHVA_cao, CaHVA_cai, comp19_celsius, NaR_Q10, HCN1_c, HCN1_Ehalf, v, HCN1_o_slow_inf, KCa_Q10, Na_Q10, CaHVA_F, CaHVA_R, CaHVA_e, CaHVA_Q10, HCN1_tEs, HCN1_tDs, HCN1_tCs, HCN1_tau_s, HCN1_tEf, HCN1_tDf, HCN1_tCf, HCN1_tau_f, HCN1_o_fast_inf, NaP_B_minf, NaP_V0_minf, NaP_m_inf298, KA_Q10, CaLVA_k_m_inf, CaLVA_v0_m_inf, CaLVA_shift, CaLVA_m_inf, HCN2_c, HCN2_Ehalf, HCN2_rB, HCN2_rA, HCN2_o_slow_inf, CaLVA_phi_m, CaLVA_phi_h, NaP_Q10, KM_B_ninf, KM_V0_ninf, KM_m_inf282, CaLVA_k_h_inf, CaLVA_v0_h_inf, CaLVA_h_inf, HCN2_o_fast_inf, KV_Q10, SK2_Q10, CaLVA_F, CaLVA_R, CaLVA_e, HCN2_tEs, HCN2_tDs, HCN2_tCs, HCN2_tau_s, KM_Q10, AMPA_A, AMPA_B, AMPA_g, HCN2_tEf, HCN2_tDf, HCN2_tCf, HCN2_tau_f, KA_K_ainf, KA_V0_ainf, KA_a_inf, KA_K_binf, KA_V0_binf, KA_b_inf, KM_m_tau283, CaHVA_tau_s, CaHVA_tau_u, KV_tau_n, CaLVA_h_inf267, KCa_c_inf, Na_v_inf, SK2_dirc3, SK2_dirc3_t, NaR_tau_s, KA_h_inf273, NaR_tau_f, NaP_m_tau299, KA_tau_b, KA_tau_a, SK2_dirc2, SK2_dirc2_t, SK2_invc3, SK2_invc3_t, SK2_dirc4, SK2_dirc4_t, SK2_invo1, SK2_invo1_t, KV_n_inf, KCa_tau_c, CaLVA_k_tau_h2, CaLVA_v0_tau_h2, CaLVA_k_tau_h1, CaLVA_v0_tau_h1, CaLVA_A_tau_h, CaLVA_C_tau_h, CaLVA_tau_h, CaHVA_u_inf, Na_tau_v, Na_tau_u, CaLVA_k_tau_m2, CaLVA_v0_tau_m2, CaLVA_k_tau_m1, CaLVA_v0_tau_m1, CaLVA_A_tau_m, CaLVA_C_tau_m, CaLVA_tau_m, NaR_s_inf, Na_u_inf, SK2_diro2, SK2_diro2_t, CaLVA_m_inf265, SK2_invc1, SK2_invc1_t, SK2_invo2, SK2_invo2_t, SK2_diro1, SK2_diro1_t, CaHVA_s_inf, NaR_f_inf, SK2_invc2, SK2_invc2_t, KA_m_inf271, KA_m_tau272, SK2_diff, SK2_dirc3_t_ca, CaHVA_h_inf261, KV_m_inf287, CaHVA_h_tau262, Na_m_inf292, KCa_m_tau278, Na_h_tau295, Na_h_inf294, NaR_h_inf305, NaR_m_inf303, NaR_h_tau306, CaHVA_m_tau260, KA_h_tau274, SK2_dirc2_t_ca, KV_m_tau288, NaR_m_tau304, Na_m_tau293, SK2_dirc4_t_ca, CaHVA_m_inf259, KCa_m_inf277, CaLVA_m_tau266, CaLVA_h_tau268, HCN2_o_fast, HCN1_o_slow, HCN1_o_fast, HCN2_o_slow, NaP_m302, KM_m286, CaHVA_h264, CaHVA_m263, KA_m275, Na_m296, KCa_m281, KA_h276, Na_h297, CaLVA_m269, CaLVA_h270, NaR_m307, NaR_h308, KV_m291, i_AMPA, i_Lkg, i_HCN1, i_HCN2, i, i_CaHVA, i_CaLVA, i_NaP, i_NaR, i_Na, ina, i_KA, i_KCa, i_KM, i_KV, i_SK2, ik, SK2_SK2_zc4, SK2_SK2_zo2, SK2_SK2_zc3, SK2_SK2_zo1, SK2_SK2_zc2, KM_V0beta_n, Na_V0alpha_u, NaR_Shiftalpha_s, AMPA_e, NaR_Aalpha_f, KA_Kalpha_b, KA_Kalpha_a, KCa_Kbeta_c, SK2_gbar, KV_Abeta_n, KM_Kalpha_n, KA_g, KA_e, Lkg_e, Lkg_g, KA_Abeta_b, NaR_V0alpha_f, KA_Abeta_a, NaR_V0alpha_s, CaLVA_g, NaP_V0alpha_m, CaHVA_Aalpha_s, CaHVA_Aalpha_u, HCN2_erev, KA_Kbeta_a, KA_Kbeta_b, Lkg_gbar, KM_gbar, AMPA_scale_factor, Na_gbar, NaP_gbar, ca_d, AMPA_tp, Na_erev, NaR_gbar, AMPA_tau1, AMPA_tau2, ca_F, KA_V0alpha_b, KA_V0alpha_a, KA_Aalpha_b, KA_Aalpha_a, KM_Kbeta_n, KA_gbar, KA_erev, HCN1_rB, HCN1_rA, AMPA_tauA, AMPA_tauB, NaR_Abeta_s, comp19_V_t, NaR_Abeta_f, Na_e, Na_g, NaR_Kalpha_f, NaR_Kalpha_s, KV_Aalpha_n, KCa_Bbeta_c, NaR_e, NaR_g, KCa_Abeta_c, CaHVA_gbar, KCa_g, KCa_e, KCa_gbar, Lkg_erev, NaP_Kalpha_m, ca_cai0, HCN1_erev, HCN1_gbar, KV_V0beta_n, KA_V0beta_b, KA_V0beta_a, NaP_g, NaP_e, NaR_erev, KCa_Aalpha_c, ca2_ca2i0, NaR_V0beta_s, SK2_erev, comp21_L, KV_Kbeta_n, NaR_Aalpha_s, Na_Kbeta_u, Na_Kbeta_v, KCa_Kalpha_c, comp20_c, CaLVA_valence, NaP_Aalpha_m, HCN2_gbar, KM_erev, ca2_beta, NaP_V0beta_m, KV_Kalpha_n, HCN2_e, HCN2_g, NaP_Abeta_m, NaR_V0beta_f, CaHVA_Abeta_u, ca2_d, SK2_g, HCN1_e, SK2_e, HCN1_g, KV_gbar, ca2_F, KM_Abeta_n, NaP_erev, KM_V0alpha_n, CaHVA_V0alpha_s, NaP_Kbeta_m, CaHVA_Abeta_s, CaHVA_V0alpha_u, Na_Aalpha_u, Na_Aalpha_v, NaR_Kbeta_f, NaR_Kbeta_s, CaHVA_V0beta_u, CaHVA_V0beta_s, ca_beta, CaHVA_Kalpha_s, CaHVA_Kalpha_u, KV_g, CaHVA_g, KV_e, KCa_Balpha_c, NaR_Shiftbeta_s, CaLVA_gbar, KM_e, Na_V0beta_u, KM_g, Na_V0beta_v, KV_V0alpha_n, ca2_valence, KV_erev, Na_Kalpha_u, Na_Kalpha_v, KM_Aalpha_n, comp21_diam, Na_Abeta_v, Na_Abeta_u, KCa_erev, CaHVA_Kbeta_u, CaHVA_Kbeta_s, Na_V0alpha_v, SK2_SK2_z;

   const Parameters_ *params = &p;

   r_ = 0;

   memset(y_,0,28*sizeof(double));

   KM_V0beta_n  =  p.KM_V0beta_n;
   Na_V0alpha_u  =  p.Na_V0alpha_u;
   NaR_Shiftalpha_s  =  p.NaR_Shiftalpha_s;
   AMPA_e  =  p.AMPA_e;
   NaR_Aalpha_f  =  p.NaR_Aalpha_f;
   CaLVA_k_m_inf  =  p.CaLVA_k_m_inf;
   KA_Kalpha_b  =  p.KA_Kalpha_b;
   KA_Kalpha_a  =  p.KA_Kalpha_a;
   KCa_Kbeta_c  =  p.KCa_Kbeta_c;
   SK2_invo1  =  p.SK2_invo1;
   SK2_invo2  =  p.SK2_invo2;
   SK2_gbar  =  p.SK2_gbar;
   KV_Abeta_n  =  p.KV_Abeta_n;
   KM_Kalpha_n  =  p.KM_Kalpha_n;
   KA_g  =  p.KA_g;
   KA_e  =  p.KA_e;
   Lkg_e  =  p.Lkg_e;
   Lkg_g  =  p.Lkg_g;
   HCN1_tEf  =  p.HCN1_tEf;
   KA_Abeta_b  =  p.KA_Abeta_b;
   NaR_V0alpha_f  =  p.NaR_V0alpha_f;
   KA_Abeta_a  =  p.KA_Abeta_a;
   NaR_V0alpha_s  =  p.NaR_V0alpha_s;
   CaLVA_F  =  p.CaLVA_F;
   HCN1_tEs  =  p.HCN1_tEs;
   KM_B_ninf  =  p.KM_B_ninf;
   CaLVA_R  =  p.CaLVA_R;
   HCN1_tDs  =  p.HCN1_tDs;
   CaLVA_g  =  p.CaLVA_g;
   NaP_V0alpha_m  =  p.NaP_V0alpha_m;
   SK2_diro1  =  p.SK2_diro1;
   CaHVA_Aalpha_s  =  p.CaHVA_Aalpha_s;
   CaHVA_Aalpha_u  =  p.CaHVA_Aalpha_u;
   SK2_diro2  =  p.SK2_diro2;
   HCN2_erev  =  p.HCN2_erev;
   HCN1_Ehalf  =  p.HCN1_Ehalf;
   KA_V0_binf  =  p.KA_V0_binf;
   KA_Kbeta_a  =  p.KA_Kbeta_a;
   KA_Kbeta_b  =  p.KA_Kbeta_b;
   Lkg_gbar  =  p.Lkg_gbar;
   KM_gbar  =  p.KM_gbar;
   AMPA_scale_factor  =  p.AMPA_scale_factor;
   Na_gbar  =  p.Na_gbar;
   CaLVA_v0_m_inf  =  p.CaLVA_v0_m_inf;
   NaP_gbar  =  p.NaP_gbar;
   ca_d  =  p.ca_d;
   AMPA_tp  =  p.AMPA_tp;
   HCN2_tCs  =  p.HCN2_tCs;
   CaLVA_k_h_inf  =  p.CaLVA_k_h_inf;
   Na_erev  =  p.Na_erev;
   NaP_V0_minf  =  p.NaP_V0_minf;
   NaR_gbar  =  p.NaR_gbar;
   AMPA_tau1  =  p.AMPA_tau1;
   AMPA_tau2  =  p.AMPA_tau2;
   ca_F  =  p.ca_F;
   KA_V0alpha_b  =  p.KA_V0alpha_b;
   KA_V0alpha_a  =  p.KA_V0alpha_a;
   KA_Aalpha_b  =  p.KA_Aalpha_b;
   KA_Aalpha_a  =  p.KA_Aalpha_a;
   KM_Kbeta_n  =  p.KM_Kbeta_n;
   CaLVA_v0_tau_m1  =  p.CaLVA_v0_tau_m1;
   CaLVA_v0_tau_m2  =  p.CaLVA_v0_tau_m2;
   KA_gbar  =  p.KA_gbar;
   KA_erev  =  p.KA_erev;
   HCN1_rB  =  p.HCN1_rB;
   HCN1_rA  =  p.HCN1_rA;
   KA_V0_ainf  =  p.KA_V0_ainf;
   AMPA_tauA  =  p.AMPA_tauA;
   AMPA_tauB  =  p.AMPA_tauB;
   CaLVA_v0_tau_h2  =  p.CaLVA_v0_tau_h2;
   CaLVA_v0_tau_h1  =  p.CaLVA_v0_tau_h1;
   NaR_Abeta_s  =  p.NaR_Abeta_s;
   comp19_V_t  =  p.comp19_V_t;
   HCN2_Ehalf  =  p.HCN2_Ehalf;
   CaLVA_v0_h_inf  =  p.CaLVA_v0_h_inf;
   NaR_Abeta_f  =  p.NaR_Abeta_f;
   ca2_ca2o  =  p.ca2_ca2o;
   Na_e  =  p.Na_e;
   Na_g  =  p.Na_g;
   NaR_Kalpha_f  =  p.NaR_Kalpha_f;
   SK2_dirc4  =  p.SK2_dirc4;
   SK2_dirc3  =  p.SK2_dirc3;
   SK2_dirc2  =  p.SK2_dirc2;
   NaR_Kalpha_s  =  p.NaR_Kalpha_s;
   KV_Aalpha_n  =  p.KV_Aalpha_n;
   KCa_Bbeta_c  =  p.KCa_Bbeta_c;
   NaR_e  =  p.NaR_e;
   NaR_g  =  p.NaR_g;
   KCa_Abeta_c  =  p.KCa_Abeta_c;
   CaHVA_gbar  =  p.CaHVA_gbar;
   KCa_g  =  p.KCa_g;
   KCa_e  =  p.KCa_e;
   HCN2_rA  =  p.HCN2_rA;
   HCN2_rB  =  p.HCN2_rB;
   SK2_invc1  =  p.SK2_invc1;
   SK2_invc2  =  p.SK2_invc2;
   SK2_invc3  =  p.SK2_invc3;
   KCa_gbar  =  p.KCa_gbar;
   Lkg_erev  =  p.Lkg_erev;
   NaP_Kalpha_m  =  p.NaP_Kalpha_m;
   KA_K_ainf  =  p.KA_K_ainf;
   ca_cai0  =  p.ca_cai0;
   HCN1_erev  =  p.HCN1_erev;
   HCN1_gbar  =  p.HCN1_gbar;
   KV_V0beta_n  =  p.KV_V0beta_n;
   KA_V0beta_b  =  p.KA_V0beta_b;
   KA_V0beta_a  =  p.KA_V0beta_a;
   NaP_g  =  p.NaP_g;
   NaP_e  =  p.NaP_e;
   NaP_B_minf  =  p.NaP_B_minf;
   NaR_erev  =  p.NaR_erev;
   KCa_Aalpha_c  =  p.KCa_Aalpha_c;
   ca2_ca2i0  =  p.ca2_ca2i0;
   NaR_V0beta_s  =  p.NaR_V0beta_s;
   SK2_erev  =  p.SK2_erev;
   comp21_L  =  p.comp21_L;
   KV_Kbeta_n  =  p.KV_Kbeta_n;
   NaR_Aalpha_s  =  p.NaR_Aalpha_s;
   Na_Kbeta_u  =  p.Na_Kbeta_u;
   Na_Kbeta_v  =  p.Na_Kbeta_v;
   KCa_Kalpha_c  =  p.KCa_Kalpha_c;
   comp20_c  =  p.comp20_c;
   CaLVA_valence  =  p.CaLVA_valence;
   NaP_Aalpha_m  =  p.NaP_Aalpha_m;
   HCN2_gbar  =  p.HCN2_gbar;
   KM_erev  =  p.KM_erev;
   ca2_beta  =  p.ca2_beta;
   CaLVA_C_tau_h  =  p.CaLVA_C_tau_h;
   NaP_V0beta_m  =  p.NaP_V0beta_m;
   KV_Kalpha_n  =  p.KV_Kalpha_n;
   HCN2_c  =  p.HCN2_c;
   HCN2_e  =  p.HCN2_e;
   HCN2_g  =  p.HCN2_g;
   NaP_Abeta_m  =  p.NaP_Abeta_m;
   comp19_celsius  =  p.comp19_celsius;
   NaR_V0beta_f  =  p.NaR_V0beta_f;
   CaHVA_Abeta_u  =  p.CaHVA_Abeta_u;
   ca2_d  =  p.ca2_d;
   CaLVA_shift  =  p.CaLVA_shift;
   SK2_g  =  p.SK2_g;
   HCN1_c  =  p.HCN1_c;
   CaLVA_C_tau_m  =  p.CaLVA_C_tau_m;
   CaLVA_A_tau_h  =  p.CaLVA_A_tau_h;
   HCN1_e  =  p.HCN1_e;
   SK2_e  =  p.SK2_e;
   HCN1_g  =  p.HCN1_g;
   CaLVA_A_tau_m  =  p.CaLVA_A_tau_m;
   KV_gbar  =  p.KV_gbar;
   ca2_F  =  p.ca2_F;
   KM_Abeta_n  =  p.KM_Abeta_n;
   NaP_erev  =  p.NaP_erev;
   KM_V0alpha_n  =  p.KM_V0alpha_n;
   HCN2_tEs  =  p.HCN2_tEs;
   CaHVA_V0alpha_s  =  p.CaHVA_V0alpha_s;
   NaP_Kbeta_m  =  p.NaP_Kbeta_m;
   CaHVA_Abeta_s  =  p.CaHVA_Abeta_s;
   CaHVA_V0alpha_u  =  p.CaHVA_V0alpha_u;
   KM_V0_ninf  =  p.KM_V0_ninf;
   Na_Aalpha_u  =  p.Na_Aalpha_u;
   Na_Aalpha_v  =  p.Na_Aalpha_v;
   KA_K_binf  =  p.KA_K_binf;
   NaR_Kbeta_f  =  p.NaR_Kbeta_f;
   NaR_Kbeta_s  =  p.NaR_Kbeta_s;
   CaHVA_R  =  p.CaHVA_R;
   CaHVA_V0beta_u  =  p.CaHVA_V0beta_u;
   CaHVA_V0beta_s  =  p.CaHVA_V0beta_s;
   ca_beta  =  p.ca_beta;
   CaLVA_k_tau_h1  =  p.CaLVA_k_tau_h1;
   CaLVA_k_tau_h2  =  p.CaLVA_k_tau_h2;
   CaHVA_F  =  p.CaHVA_F;
   HCN2_tEf  =  p.HCN2_tEf;
   CaHVA_Kalpha_s  =  p.CaHVA_Kalpha_s;
   CaHVA_Kalpha_u  =  p.CaHVA_Kalpha_u;
   CaLVA_k_tau_m2  =  p.CaLVA_k_tau_m2;
   KV_g  =  p.KV_g;
   CaLVA_k_tau_m1  =  p.CaLVA_k_tau_m1;
   CaHVA_g  =  p.CaHVA_g;
   KV_e  =  p.KV_e;
   KCa_Balpha_c  =  p.KCa_Balpha_c;
   ca_cao  =  p.ca_cao;
   HCN1_tCf  =  p.HCN1_tCf;
   NaR_Shiftbeta_s  =  p.NaR_Shiftbeta_s;
   CaLVA_gbar  =  p.CaLVA_gbar;
   KM_e  =  p.KM_e;
   Na_V0beta_u  =  p.Na_V0beta_u;
   KM_g  =  p.KM_g;
   Na_V0beta_v  =  p.Na_V0beta_v;
   KV_V0alpha_n  =  p.KV_V0alpha_n;
   ca2_valence  =  p.ca2_valence;
   HCN1_tCs  =  p.HCN1_tCs;
   KV_erev  =  p.KV_erev;
   HCN2_tDs  =  p.HCN2_tDs;
   Na_Kalpha_u  =  p.Na_Kalpha_u;
   Na_Kalpha_v  =  p.Na_Kalpha_v;
   HCN1_tDf  =  p.HCN1_tDf;
   KM_Aalpha_n  =  p.KM_Aalpha_n;
   HCN2_tCf  =  p.HCN2_tCf;
   comp21_diam  =  p.comp21_diam;
   Na_Abeta_v  =  p.Na_Abeta_v;
   Na_Abeta_u  =  p.Na_Abeta_u;
   KCa_erev  =  p.KCa_erev;
   SK2_diff  =  p.SK2_diff;
   CaHVA_Kbeta_u  =  p.CaHVA_Kbeta_u;
   CaHVA_Kbeta_s  =  p.CaHVA_Kbeta_s;
   Na_V0alpha_v  =  p.Na_V0alpha_v;
   HCN2_tDf  =  p.HCN2_tDf;

   ca2_ica2  =  ica2;
   ca_ca  =  5e-05;
   cai  =  ca_ca;
   KCa_cai  =  cai;
   SK2_cai  =  cai;
   ca2_ca2  =  5e-05;
   ca2i  =  ca2_ca2;
   CaLVA_ca2i  =  ca2i;
   ca2o  =  ca2_ca2o;
   CaLVA_ca2o  =  ca2o;
   ca_ica  =  ica;
   cao  =  ca_cao;
   CaHVA_cao  =  cao;
   CaHVA_cai  =  cai;
   NaR_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   v  =  -65.0;
   HCN1_o_slow_inf  =  (1.0 + -(HCN1_r(v, params))) * (HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params));
   KCa_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   Na_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   CaHVA_e  =  (1000.0 * CaHVA_R * (comp19_celsius + 273.15)) / (2.0 * CaHVA_F) * log(CaHVA_cao / CaHVA_cai);
   CaHVA_Q10  =  pow(3.0, (comp19_celsius + -20.0) / 10.0);
   HCN1_tau_s  =  HCN1_tau(v, HCN1_tCs, HCN1_tDs, HCN1_tEs, params);
   HCN1_tau_f  =  HCN1_tau(v, HCN1_tCf, HCN1_tDf, HCN1_tEf, params);
   HCN1_o_fast_inf  =  HCN1_r(v, params) * HCN1_o_inf(v, HCN1_Ehalf, HCN1_c, params);
   NaP_m_inf298  =  1.0 / (1.0 + exp(-(v + -(NaP_V0_minf)) / NaP_B_minf));
   KA_Q10  =  pow(3.0, (comp19_celsius + -25.5) / 10.0);
   CaLVA_m_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_m_inf)) / CaLVA_k_m_inf));
   HCN2_o_slow_inf  =  (1.0 + -(HCN2_r(v, HCN2_rA, HCN2_rB, params))) * (HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params));
   CaLVA_phi_m  =  pow(5.0, (comp19_celsius + -24.0) / 10.0);
   CaLVA_phi_h  =  pow(3.0, (comp19_celsius + -24.0) / 10.0);
   NaP_Q10  =  pow(3.0, (comp19_celsius + -30.0) / 10.0);
   KM_m_inf282  =  1.0 / (1.0 + exp(-(v + -(KM_V0_ninf)) / KM_B_ninf));
   CaLVA_h_inf  =  1.0 / (1.0 + exp((v + CaLVA_shift + -(CaLVA_v0_h_inf)) / CaLVA_k_h_inf));
   HCN2_o_fast_inf  =  HCN2_r(v, HCN2_rA, HCN2_rB, params) * HCN2_o_inf(v, HCN2_Ehalf, HCN2_c, params);
   KV_Q10  =  pow(3.0, (comp19_celsius + -6.3) / 10.0);
   SK2_Q10  =  pow(3.0, (comp19_celsius + -23.0) / 10.0);
   CaLVA_e  =  (1000.0 * CaLVA_R * (comp19_celsius + 273.15)) / (2.0 * CaLVA_F) * log(CaLVA_ca2o / CaLVA_ca2i);
   HCN2_tau_s  =  HCN2_tau_slow(v, HCN2_tCs, HCN2_tDs, HCN2_tEs, params);
   KM_Q10  =  pow(3.0, (comp19_celsius + -22.0) / 10.0);
   AMPA_A  =  0.0;
   AMPA_B  =  0.0;
   AMPA_g  =  AMPA_B + -(AMPA_A);
   HCN2_tau_f  =  HCN2_tau_fast(v, HCN2_tCf, HCN2_tDf, HCN2_tEf, params);
   KA_a_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_ainf)) / KA_K_ainf));
   KA_b_inf  =  1.0 / (1.0 + exp((v + -(KA_V0_binf)) / KA_K_binf));
   KM_m_tau283  =  1.0 / (KM_alpha_n(v, KM_Q10, params) + KM_beta_n(v, KM_Q10, params));
   CaHVA_tau_s  =  1.0 / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   CaHVA_tau_u  =  1.0 / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   KV_tau_n  =  1.0 / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   CaLVA_h_inf267  =  CaLVA_h_inf;
   KCa_c_inf  =  (KCa_alpha_c(v, KCa_cai, KCa_Q10, params)) / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   Na_v_inf  =  (Na_alpha_v(v, Na_Q10, params)) / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   SK2_dirc3_t  =  SK2_dirc3 * SK2_Q10;
   NaR_tau_s  =  1.0 / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   KA_h_inf273  =  KA_b_inf;
   NaR_tau_f  =  1.0 / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   NaP_m_tau299  =  5.0 / (NaP_alpha_m(v, NaP_Q10, params) + NaP_beta_m(v, NaP_Q10, params));
   KA_tau_b  =  1.0 / (KA_alpha_b(v, KA_Q10, params) + KA_beta_b(v, KA_Q10, params));
   KA_tau_a  =  1.0 / (KA_alpha_a(v, KA_Q10, params) + KA_beta_a(v, KA_Q10, params));
   SK2_dirc2_t  =  SK2_dirc2 * SK2_Q10;
   SK2_invc3_t  =  SK2_invc3 * SK2_Q10;
   SK2_dirc4_t  =  SK2_dirc4 * SK2_Q10;
   SK2_invo1_t  =  SK2_invo1 * SK2_Q10;
   KV_n_inf  =  (KV_alpha_n(v, KV_Q10, params)) / (KV_alpha_n(v, KV_Q10, params) + KV_beta_n(v, KV_Q10, params));
   KCa_tau_c  =  1.0 / (KCa_alpha_c(v, KCa_cai, KCa_Q10, params) + KCa_beta_c(v, KCa_cai, KCa_Q10, params));
   CaLVA_tau_h  =  (CaLVA_C_tau_h + CaLVA_A_tau_h / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_h1)) / CaLVA_k_tau_h1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_h2)) / CaLVA_k_tau_h2))) / CaLVA_phi_h;
   CaHVA_u_inf  =  (CaHVA_alpha_u(v, CaHVA_Q10, params)) / (CaHVA_alpha_u(v, CaHVA_Q10, params) + CaHVA_beta_u(v, CaHVA_Q10, params));
   Na_tau_v  =  1.0 / (Na_alpha_v(v, Na_Q10, params) + Na_beta_v(v, Na_Q10, params));
   Na_tau_u  =  1.0 / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   CaLVA_tau_m  =  (CaLVA_C_tau_m + CaLVA_A_tau_m / (exp((v + CaLVA_shift + -(CaLVA_v0_tau_m1)) / CaLVA_k_tau_m1) + exp((v + CaLVA_shift + -(CaLVA_v0_tau_m2)) / CaLVA_k_tau_m2))) / CaLVA_phi_m;
   NaR_s_inf  =  (NaR_alpha_s(v, NaR_Q10, params)) / (NaR_alpha_s(v, NaR_Q10, params) + NaR_beta_s(v, NaR_Q10, params));
   Na_u_inf  =  (Na_alpha_u(v, Na_Q10, params)) / (Na_alpha_u(v, Na_Q10, params) + Na_beta_u(v, Na_Q10, params));
   SK2_diro2_t  =  SK2_diro2 * SK2_Q10;
   CaLVA_m_inf265  =  CaLVA_m_inf;
   SK2_invc1_t  =  SK2_invc1 * SK2_Q10;
   SK2_invo2_t  =  SK2_invo2 * SK2_Q10;
   SK2_diro1_t  =  SK2_diro1 * SK2_Q10;
   CaHVA_s_inf  =  (CaHVA_alpha_s(v, CaHVA_Q10, params)) / (CaHVA_alpha_s(v, CaHVA_Q10, params) + CaHVA_beta_s(v, CaHVA_Q10, params));
   NaR_f_inf  =  (NaR_alpha_f(v, NaR_Q10, params)) / (NaR_alpha_f(v, NaR_Q10, params) + NaR_beta_f(v, NaR_Q10, params));
   SK2_invc2_t  =  SK2_invc2 * SK2_Q10;
   KA_m_inf271  =  KA_a_inf;
   KA_m_tau272  =  KA_tau_a;
   SK2_dirc3_t_ca  =  SK2_dirc3_t * SK2_cai / SK2_diff;
   CaHVA_h_inf261  =  CaHVA_u_inf;
   KV_m_inf287  =  KV_n_inf;
   CaHVA_h_tau262  =  CaHVA_tau_u;
   Na_m_inf292  =  Na_u_inf;
   KCa_m_tau278  =  KCa_tau_c;
   Na_h_tau295  =  Na_tau_v;
   Na_h_inf294  =  Na_v_inf;
   NaR_h_inf305  =  NaR_f_inf;
   NaR_m_inf303  =  NaR_s_inf;
   NaR_h_tau306  =  NaR_tau_f;
   CaHVA_m_tau260  =  CaHVA_tau_s;
   KA_h_tau274  =  KA_tau_b;
   SK2_dirc2_t_ca  =  SK2_dirc2_t * SK2_cai / SK2_diff;
   KV_m_tau288  =  KV_tau_n;
   NaR_m_tau304  =  NaR_tau_s;
   Na_m_tau293  =  Na_tau_u;
   SK2_dirc4_t_ca  =  SK2_dirc4_t * SK2_cai / SK2_diff;
   CaHVA_m_inf259  =  CaHVA_s_inf;
   KCa_m_inf277  =  KCa_c_inf;
   CaLVA_m_tau266  =  CaLVA_tau_m;
   CaLVA_h_tau268  =  CaLVA_tau_h;
   HCN2_o_fast  =  HCN2_o_fast_inf;
   HCN1_o_slow  =  HCN1_o_slow_inf;
   HCN1_o_fast  =  HCN1_o_fast_inf;
   HCN2_o_slow  =  HCN2_o_slow_inf;
   NaP_m302  =  1.0 / (1.0 + exp(-(v + -(NaP_V0_minf)) / NaP_B_minf));
   KM_m286  =  1.0 / (1.0 + exp(-(v + -(KM_V0_ninf)) / KM_B_ninf));
   CaHVA_h264  =  CaHVA_u_inf;
   CaHVA_m263  =  CaHVA_s_inf;
   KA_m275  =  KA_a_inf;
   Na_m296  =  Na_u_inf;
   KCa_m281  =  KCa_c_inf;
   KA_h276  =  KA_b_inf;
   Na_h297  =  Na_v_inf;
   CaLVA_m269  =  CaLVA_m_inf;
   CaLVA_h270  =  CaLVA_h_inf;
   NaR_m307  =  NaR_s_inf;
   NaR_h308  =  NaR_f_inf;
   KV_m291  =  KV_n_inf;
    
   y_[0]  =  v;
   y_[24]  =  ca_ca;
   y_[25]  =  ca2_ca2;
   y_[26]  =  AMPA_B;
   y_[27]  =  AMPA_A;
   y_[20]  =  HCN2_o_fast;
   y_[21]  =  HCN1_o_slow;
   y_[22]  =  HCN1_o_fast;
   y_[23]  =  HCN2_o_slow;
   y_[18]  =  NaP_m302;
   y_[19]  =  KM_m286;
   y_[1]  =  CaHVA_h264;
   y_[7]  =  CaHVA_m263;
   y_[8]  =  KA_m275;
   y_[9]  =  Na_m296;
   y_[10]  =  KCa_m281;
   y_[11]  =  KA_h276;
   y_[12]  =  Na_h297;
   y_[13]  =  CaLVA_m269;
   y_[14]  =  CaLVA_h270;
   y_[15]  =  NaR_m307;
   y_[16]  =  NaR_h308;
   y_[17]  =  KV_m291;

   if (!((M_PI * comp21_L * comp21_diam) > (0.0))) 
      { throw BadProperty ("Constraint (> (* PI comp21:L comp21:diam) 0.0) is not satisfied."); }; 

   if (!((KA_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> KA:gbar 0.0) is not satisfied."); }; 

   if (!((KCa_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> KCa:gbar 0.0) is not satisfied."); }; 

   if (!((KM_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> KM:gbar 0.0) is not satisfied."); }; 

   if (!((NaP_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> NaP:gbar 0.0) is not satisfied."); }; 

   if (!((KV_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> KV:gbar 0.0) is not satisfied."); }; 

   if (!((SK2_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> SK2:gbar 0.0) is not satisfied."); }; 

   if (!((Lkg_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> Lkg:gbar 0.0) is not satisfied."); }; 

   if (!((NaR_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> NaR:gbar 0.0) is not satisfied."); }; 

   if (!((CaLVA_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> CaLVA:gbar 0.0) is not satisfied."); }; 

   if (!((Na_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> Na:gbar 0.0) is not satisfied."); }; 

   if (!((CaHVA_g) > (0.0))) 
      { throw BadProperty ("Constraint (> CaHVA:g 0.0) is not satisfied."); }; 

   if (!((HCN1_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> HCN1:gbar 0.0) is not satisfied."); }; 

   if (!((HCN2_gbar) > (0.0))) 
      { throw BadProperty ("Constraint (> HCN2:gbar 0.0) is not satisfied."); }; 




   gsl_vector *ssvect316;
   ssvect316 = gsl_vector_alloc (5);
   fsolve (Golgi_steadystate, 5, ssvect316,
           (void *)&p, "Golgi");
             
   y_[0] = v;

   y_[1] = CaHVA_h264;

   y_[2] = gsl_vector_get(ssvect316, 0);

   y_[3] = gsl_vector_get(ssvect316, 1);

   y_[4] = gsl_vector_get(ssvect316, 2);

   y_[5] = gsl_vector_get(ssvect316, 3);

   y_[6] = gsl_vector_get(ssvect316, 4);

   y_[7] = CaHVA_m263;

   y_[8] = KA_m275;

   y_[9] = Na_m296;

   y_[10] = KCa_m281;

   y_[11] = KA_h276;

   y_[12] = Na_h297;

   y_[13] = CaLVA_m269;

   y_[14] = CaLVA_h270;

   y_[15] = NaR_m307;

   y_[16] = NaR_h308;

   y_[17] = KV_m291;

   y_[18] = NaP_m302;

   y_[19] = KM_m286;

   y_[20] = HCN2_o_fast;

   y_[21] = HCN1_o_slow;

   y_[22] = HCN1_o_fast;

   y_[23] = HCN2_o_slow;

   y_[24] = ca_ca;

   y_[25] = ca2_ca2;

   y_[26] = AMPA_B;

   y_[27] = AMPA_A;


   gsl_vector_free (ssvect316);

   SK2_SK2_z  =  SK2_SK2_zo1 + SK2_SK2_zo2;
    
   i_AMPA  =  (100.0 / (M_PI * comp21_L * comp21_diam)) * AMPA_g * (v - AMPA_e);
   i_Lkg  =  Lkg_gbar * (v - Lkg_erev);
   i_HCN1  =  (HCN1_gbar * (HCN1_o_slow + HCN1_o_fast)) * (v - HCN1_erev);
   i_HCN2  =  (HCN2_gbar * (HCN2_o_slow + HCN2_o_fast)) * (v - HCN2_erev);
   i  =  i_AMPA + i_Lkg + i_HCN1 + i_HCN2;
   i_CaHVA  =  (CaHVA_g * pow(CaHVA_m263, 2.0) * CaHVA_h264) * (v - CaHVA_e);
   ica  =  i_CaHVA;
   i_CaLVA  =  (CaLVA_gbar * pow(CaLVA_m269, 2.0) * CaLVA_h270) * (v - CaLVA_e);
   ica2  =  i_CaLVA;
   i_NaP  =  (NaP_gbar * NaP_m302) * (v - NaP_erev);
   i_NaR  =  (NaR_gbar * NaR_m307 * NaR_h308) * (v - NaR_erev);
   i_Na  =  (Na_gbar * pow(Na_m296, 3.0) * Na_h297) * (v - Na_erev);
   ina  =  i_NaP + i_NaR + i_Na;
   i_KA  =  (KA_gbar * pow(KA_m275, 3.0) * KA_h276) * (v - KA_erev);
   i_KCa  =  (KCa_gbar * KCa_m281) * (v - KCa_erev);
   i_KM  =  (KM_gbar * KM_m286) * (v - KM_erev);
   i_KV  =  (KV_gbar * pow(KV_m291, 4.0)) * (v - KV_erev);
   i_SK2  =  (SK2_gbar * SK2_SK2_z) * (v - SK2_erev);
   ik  =  i_KA + i_KCa + i_KM + i_KV + i_SK2;


}


Golgi::State_::State_ (const State_& s)  
{

  r_ = s.r_;
        
  for ( int i = 0 ; i < 28 ; ++i ) 
  {
      y_[i] = s.y_[i];
  }

}


Golgi::State_& Golgi::State_::operator=(const State_& s)
{

  r_ = s.r_;
        
  assert(this != &s);  
  for ( size_t i = 0 ; i < 28 ; ++i )
       y_[i] = s.y_[i];

  return *this;

}



void Golgi::Parameters_::get (DictionaryDatum &d) const
{

   def<double_t>(d, "KM_V0beta_n", KM_V0beta_n);
   def<double_t>(d, "Na_V0alpha_u", Na_V0alpha_u);
   def<double_t>(d, "NaR_Shiftalpha_s", NaR_Shiftalpha_s);
   def<double_t>(d, "AMPA_e", AMPA_e);
   def<double_t>(d, "NaR_Aalpha_f", NaR_Aalpha_f);
   def<double_t>(d, "CaLVA_k_m_inf", CaLVA_k_m_inf);
   def<double_t>(d, "KA_Kalpha_b", KA_Kalpha_b);
   def<double_t>(d, "KA_Kalpha_a", KA_Kalpha_a);
   def<double_t>(d, "KCa_Kbeta_c", KCa_Kbeta_c);
   def<double_t>(d, "SK2_invo1", SK2_invo1);
   def<double_t>(d, "SK2_invo2", SK2_invo2);
   def<double_t>(d, "SK2_gbar", SK2_gbar);
   def<double_t>(d, "KV_Abeta_n", KV_Abeta_n);
   def<double_t>(d, "KM_Kalpha_n", KM_Kalpha_n);
   def<double_t>(d, "KA_g", KA_g);
   def<double_t>(d, "KA_e", KA_e);
   def<double_t>(d, "Lkg_e", Lkg_e);
   def<double_t>(d, "Lkg_g", Lkg_g);
   def<double_t>(d, "HCN1_tEf", HCN1_tEf);
   def<double_t>(d, "KA_Abeta_b", KA_Abeta_b);
   def<double_t>(d, "NaR_V0alpha_f", NaR_V0alpha_f);
   def<double_t>(d, "KA_Abeta_a", KA_Abeta_a);
   def<double_t>(d, "NaR_V0alpha_s", NaR_V0alpha_s);
   def<double_t>(d, "CaLVA_F", CaLVA_F);
   def<double_t>(d, "HCN1_tEs", HCN1_tEs);
   def<double_t>(d, "KM_B_ninf", KM_B_ninf);
   def<double_t>(d, "CaLVA_R", CaLVA_R);
   def<double_t>(d, "HCN1_tDs", HCN1_tDs);
   def<double_t>(d, "CaLVA_g", CaLVA_g);
   def<double_t>(d, "NaP_V0alpha_m", NaP_V0alpha_m);
   def<double_t>(d, "SK2_diro1", SK2_diro1);
   def<double_t>(d, "CaHVA_Aalpha_s", CaHVA_Aalpha_s);
   def<double_t>(d, "CaHVA_Aalpha_u", CaHVA_Aalpha_u);
   def<double_t>(d, "SK2_diro2", SK2_diro2);
   def<double_t>(d, "HCN2_erev", HCN2_erev);
   def<double_t>(d, "HCN1_Ehalf", HCN1_Ehalf);
   def<double_t>(d, "KA_V0_binf", KA_V0_binf);
   def<double_t>(d, "KA_Kbeta_a", KA_Kbeta_a);
   def<double_t>(d, "KA_Kbeta_b", KA_Kbeta_b);
   def<double_t>(d, "Lkg_gbar", Lkg_gbar);
   def<double_t>(d, "KM_gbar", KM_gbar);
   def<double_t>(d, "AMPA_scale_factor", AMPA_scale_factor);
   def<double_t>(d, "Na_gbar", Na_gbar);
   def<double_t>(d, "CaLVA_v0_m_inf", CaLVA_v0_m_inf);
   def<double_t>(d, "NaP_gbar", NaP_gbar);
   def<double_t>(d, "ca_d", ca_d);
   def<double_t>(d, "AMPA_tp", AMPA_tp);
   def<double_t>(d, "HCN2_tCs", HCN2_tCs);
   def<double_t>(d, "CaLVA_k_h_inf", CaLVA_k_h_inf);
   def<double_t>(d, "Na_erev", Na_erev);
   def<double_t>(d, "NaP_V0_minf", NaP_V0_minf);
   def<double_t>(d, "NaR_gbar", NaR_gbar);
   def<double_t>(d, "AMPA_tau1", AMPA_tau1);
   def<double_t>(d, "AMPA_tau2", AMPA_tau2);
   def<double_t>(d, "ca_F", ca_F);
   def<double_t>(d, "KA_V0alpha_b", KA_V0alpha_b);
   def<double_t>(d, "KA_V0alpha_a", KA_V0alpha_a);
   def<double_t>(d, "KA_Aalpha_b", KA_Aalpha_b);
   def<double_t>(d, "KA_Aalpha_a", KA_Aalpha_a);
   def<double_t>(d, "KM_Kbeta_n", KM_Kbeta_n);
   def<double_t>(d, "CaLVA_v0_tau_m1", CaLVA_v0_tau_m1);
   def<double_t>(d, "CaLVA_v0_tau_m2", CaLVA_v0_tau_m2);
   def<double_t>(d, "KA_gbar", KA_gbar);
   def<double_t>(d, "KA_erev", KA_erev);
   def<double_t>(d, "HCN1_rB", HCN1_rB);
   def<double_t>(d, "HCN1_rA", HCN1_rA);
   def<double_t>(d, "KA_V0_ainf", KA_V0_ainf);
   def<double_t>(d, "AMPA_tauA", AMPA_tauA);
   def<double_t>(d, "AMPA_tauB", AMPA_tauB);
   def<double_t>(d, "CaLVA_v0_tau_h2", CaLVA_v0_tau_h2);
   def<double_t>(d, "CaLVA_v0_tau_h1", CaLVA_v0_tau_h1);
   def<double_t>(d, "NaR_Abeta_s", NaR_Abeta_s);
   def<double_t>(d, "comp19_V_t", comp19_V_t);
   def<double_t>(d, "HCN2_Ehalf", HCN2_Ehalf);
   def<double_t>(d, "CaLVA_v0_h_inf", CaLVA_v0_h_inf);
   def<double_t>(d, "NaR_Abeta_f", NaR_Abeta_f);
   def<double_t>(d, "ca2_ca2o", ca2_ca2o);
   def<double_t>(d, "Na_e", Na_e);
   def<double_t>(d, "Na_g", Na_g);
   def<double_t>(d, "NaR_Kalpha_f", NaR_Kalpha_f);
   def<double_t>(d, "SK2_dirc4", SK2_dirc4);
   def<double_t>(d, "SK2_dirc3", SK2_dirc3);
   def<double_t>(d, "SK2_dirc2", SK2_dirc2);
   def<double_t>(d, "NaR_Kalpha_s", NaR_Kalpha_s);
   def<double_t>(d, "KV_Aalpha_n", KV_Aalpha_n);
   def<double_t>(d, "KCa_Bbeta_c", KCa_Bbeta_c);
   def<double_t>(d, "NaR_e", NaR_e);
   def<double_t>(d, "NaR_g", NaR_g);
   def<double_t>(d, "KCa_Abeta_c", KCa_Abeta_c);
   def<double_t>(d, "CaHVA_gbar", CaHVA_gbar);
   def<double_t>(d, "KCa_g", KCa_g);
   def<double_t>(d, "KCa_e", KCa_e);
   def<double_t>(d, "HCN2_rA", HCN2_rA);
   def<double_t>(d, "HCN2_rB", HCN2_rB);
   def<double_t>(d, "SK2_invc1", SK2_invc1);
   def<double_t>(d, "SK2_invc2", SK2_invc2);
   def<double_t>(d, "SK2_invc3", SK2_invc3);
   def<double_t>(d, "KCa_gbar", KCa_gbar);
   def<double_t>(d, "Lkg_erev", Lkg_erev);
   def<double_t>(d, "NaP_Kalpha_m", NaP_Kalpha_m);
   def<double_t>(d, "KA_K_ainf", KA_K_ainf);
   def<double_t>(d, "ca_cai0", ca_cai0);
   def<double_t>(d, "HCN1_erev", HCN1_erev);
   def<double_t>(d, "HCN1_gbar", HCN1_gbar);
   def<double_t>(d, "KV_V0beta_n", KV_V0beta_n);
   def<double_t>(d, "KA_V0beta_b", KA_V0beta_b);
   def<double_t>(d, "KA_V0beta_a", KA_V0beta_a);
   def<double_t>(d, "NaP_g", NaP_g);
   def<double_t>(d, "NaP_e", NaP_e);
   def<double_t>(d, "NaP_B_minf", NaP_B_minf);
   def<double_t>(d, "NaR_erev", NaR_erev);
   def<double_t>(d, "KCa_Aalpha_c", KCa_Aalpha_c);
   def<double_t>(d, "ca2_ca2i0", ca2_ca2i0);
   def<double_t>(d, "NaR_V0beta_s", NaR_V0beta_s);
   def<double_t>(d, "SK2_erev", SK2_erev);
   def<double_t>(d, "comp21_L", comp21_L);
   def<double_t>(d, "KV_Kbeta_n", KV_Kbeta_n);
   def<double_t>(d, "NaR_Aalpha_s", NaR_Aalpha_s);
   def<double_t>(d, "Na_Kbeta_u", Na_Kbeta_u);
   def<double_t>(d, "Na_Kbeta_v", Na_Kbeta_v);
   def<double_t>(d, "KCa_Kalpha_c", KCa_Kalpha_c);
   def<double_t>(d, "comp20_c", comp20_c);
   def<double_t>(d, "CaLVA_valence", CaLVA_valence);
   def<double_t>(d, "NaP_Aalpha_m", NaP_Aalpha_m);
   def<double_t>(d, "HCN2_gbar", HCN2_gbar);
   def<double_t>(d, "KM_erev", KM_erev);
   def<double_t>(d, "ca2_beta", ca2_beta);
   def<double_t>(d, "CaLVA_C_tau_h", CaLVA_C_tau_h);
   def<double_t>(d, "NaP_V0beta_m", NaP_V0beta_m);
   def<double_t>(d, "KV_Kalpha_n", KV_Kalpha_n);
   def<double_t>(d, "HCN2_c", HCN2_c);
   def<double_t>(d, "HCN2_e", HCN2_e);
   def<double_t>(d, "HCN2_g", HCN2_g);
   def<double_t>(d, "NaP_Abeta_m", NaP_Abeta_m);
   def<double_t>(d, "comp19_celsius", comp19_celsius);
   def<double_t>(d, "NaR_V0beta_f", NaR_V0beta_f);
   def<double_t>(d, "CaHVA_Abeta_u", CaHVA_Abeta_u);
   def<double_t>(d, "ca2_d", ca2_d);
   def<double_t>(d, "CaLVA_shift", CaLVA_shift);
   def<double_t>(d, "SK2_g", SK2_g);
   def<double_t>(d, "HCN1_c", HCN1_c);
   def<double_t>(d, "CaLVA_C_tau_m", CaLVA_C_tau_m);
   def<double_t>(d, "CaLVA_A_tau_h", CaLVA_A_tau_h);
   def<double_t>(d, "HCN1_e", HCN1_e);
   def<double_t>(d, "SK2_e", SK2_e);
   def<double_t>(d, "HCN1_g", HCN1_g);
   def<double_t>(d, "CaLVA_A_tau_m", CaLVA_A_tau_m);
   def<double_t>(d, "KV_gbar", KV_gbar);
   def<double_t>(d, "ca2_F", ca2_F);
   def<double_t>(d, "KM_Abeta_n", KM_Abeta_n);
   def<double_t>(d, "NaP_erev", NaP_erev);
   def<double_t>(d, "KM_V0alpha_n", KM_V0alpha_n);
   def<double_t>(d, "HCN2_tEs", HCN2_tEs);
   def<double_t>(d, "CaHVA_V0alpha_s", CaHVA_V0alpha_s);
   def<double_t>(d, "NaP_Kbeta_m", NaP_Kbeta_m);
   def<double_t>(d, "CaHVA_Abeta_s", CaHVA_Abeta_s);
   def<double_t>(d, "CaHVA_V0alpha_u", CaHVA_V0alpha_u);
   def<double_t>(d, "KM_V0_ninf", KM_V0_ninf);
   def<double_t>(d, "Na_Aalpha_u", Na_Aalpha_u);
   def<double_t>(d, "Na_Aalpha_v", Na_Aalpha_v);
   def<double_t>(d, "KA_K_binf", KA_K_binf);
   def<double_t>(d, "NaR_Kbeta_f", NaR_Kbeta_f);
   def<double_t>(d, "NaR_Kbeta_s", NaR_Kbeta_s);
   def<double_t>(d, "CaHVA_R", CaHVA_R);
   def<double_t>(d, "CaHVA_V0beta_u", CaHVA_V0beta_u);
   def<double_t>(d, "CaHVA_V0beta_s", CaHVA_V0beta_s);
   def<double_t>(d, "ca_beta", ca_beta);
   def<double_t>(d, "CaLVA_k_tau_h1", CaLVA_k_tau_h1);
   def<double_t>(d, "CaLVA_k_tau_h2", CaLVA_k_tau_h2);
   def<double_t>(d, "CaHVA_F", CaHVA_F);
   def<double_t>(d, "HCN2_tEf", HCN2_tEf);
   def<double_t>(d, "CaHVA_Kalpha_s", CaHVA_Kalpha_s);
   def<double_t>(d, "CaHVA_Kalpha_u", CaHVA_Kalpha_u);
   def<double_t>(d, "CaLVA_k_tau_m2", CaLVA_k_tau_m2);
   def<double_t>(d, "KV_g", KV_g);
   def<double_t>(d, "CaLVA_k_tau_m1", CaLVA_k_tau_m1);
   def<double_t>(d, "CaHVA_g", CaHVA_g);
   def<double_t>(d, "KV_e", KV_e);
   def<double_t>(d, "KCa_Balpha_c", KCa_Balpha_c);
   def<double_t>(d, "ca_cao", ca_cao);
   def<double_t>(d, "HCN1_tCf", HCN1_tCf);
   def<double_t>(d, "NaR_Shiftbeta_s", NaR_Shiftbeta_s);
   def<double_t>(d, "CaLVA_gbar", CaLVA_gbar);
   def<double_t>(d, "KM_e", KM_e);
   def<double_t>(d, "Na_V0beta_u", Na_V0beta_u);
   def<double_t>(d, "KM_g", KM_g);
   def<double_t>(d, "Na_V0beta_v", Na_V0beta_v);
   def<double_t>(d, "KV_V0alpha_n", KV_V0alpha_n);
   def<double_t>(d, "ca2_valence", ca2_valence);
   def<double_t>(d, "HCN1_tCs", HCN1_tCs);
   def<double_t>(d, "KV_erev", KV_erev);
   def<double_t>(d, "HCN2_tDs", HCN2_tDs);
   def<double_t>(d, "Na_Kalpha_u", Na_Kalpha_u);
   def<double_t>(d, "Na_Kalpha_v", Na_Kalpha_v);
   def<double_t>(d, "HCN1_tDf", HCN1_tDf);
   def<double_t>(d, "KM_Aalpha_n", KM_Aalpha_n);
   def<double_t>(d, "HCN2_tCf", HCN2_tCf);
   def<double_t>(d, "comp21_diam", comp21_diam);
   def<double_t>(d, "Na_Abeta_v", Na_Abeta_v);
   def<double_t>(d, "Na_Abeta_u", Na_Abeta_u);
   def<double_t>(d, "KCa_erev", KCa_erev);
   def<double_t>(d, "SK2_diff", SK2_diff);
   def<double_t>(d, "CaHVA_Kbeta_u", CaHVA_Kbeta_u);
   def<double_t>(d, "CaHVA_Kbeta_s", CaHVA_Kbeta_s);
   def<double_t>(d, "Na_V0alpha_v", Na_V0alpha_v);
   def<double_t>(d, "HCN2_tDf", HCN2_tDf);
    

   def<double_t>(d, "celsius", celsius);
   def<double_t>(d, "V_t", V_t);
    
    
}

void Golgi::Parameters_::set (const DictionaryDatum &d)
{

   updateValue<double_t>(d, "KM_V0beta_n", KM_V0beta_n);

    
   updateValue<double_t>(d, "Na_V0alpha_u", Na_V0alpha_u);

    
   updateValue<double_t>(d, "NaR_Shiftalpha_s", NaR_Shiftalpha_s);

    
   updateValue<double_t>(d, "AMPA_e", AMPA_e);

    
   updateValue<double_t>(d, "NaR_Aalpha_f", NaR_Aalpha_f);

    
   updateValue<double_t>(d, "CaLVA_k_m_inf", CaLVA_k_m_inf);

    
   updateValue<double_t>(d, "KA_Kalpha_b", KA_Kalpha_b);

    
   updateValue<double_t>(d, "KA_Kalpha_a", KA_Kalpha_a);

    
   updateValue<double_t>(d, "KCa_Kbeta_c", KCa_Kbeta_c);

    
   updateValue<double_t>(d, "SK2_invo1", SK2_invo1);

    
   updateValue<double_t>(d, "SK2_invo2", SK2_invo2);

    
   updateValue<double_t>(d, "SK2_gbar", SK2_gbar);

    
   updateValue<double_t>(d, "KV_Abeta_n", KV_Abeta_n);

    
   updateValue<double_t>(d, "KM_Kalpha_n", KM_Kalpha_n);

    
   updateValue<double_t>(d, "KA_g", KA_g);

    
   updateValue<double_t>(d, "KA_e", KA_e);

    
   updateValue<double_t>(d, "Lkg_e", Lkg_e);

    
   updateValue<double_t>(d, "Lkg_g", Lkg_g);

    
   updateValue<double_t>(d, "HCN1_tEf", HCN1_tEf);

    
   updateValue<double_t>(d, "KA_Abeta_b", KA_Abeta_b);

    
   updateValue<double_t>(d, "NaR_V0alpha_f", NaR_V0alpha_f);

    
   updateValue<double_t>(d, "KA_Abeta_a", KA_Abeta_a);

    
   updateValue<double_t>(d, "NaR_V0alpha_s", NaR_V0alpha_s);

    
   updateValue<double_t>(d, "CaLVA_F", CaLVA_F);

    
   updateValue<double_t>(d, "HCN1_tEs", HCN1_tEs);

    
   updateValue<double_t>(d, "KM_B_ninf", KM_B_ninf);

    
   updateValue<double_t>(d, "CaLVA_R", CaLVA_R);

    
   updateValue<double_t>(d, "HCN1_tDs", HCN1_tDs);

    
   updateValue<double_t>(d, "CaLVA_g", CaLVA_g);

    
   updateValue<double_t>(d, "NaP_V0alpha_m", NaP_V0alpha_m);

    
   updateValue<double_t>(d, "SK2_diro1", SK2_diro1);

    
   updateValue<double_t>(d, "CaHVA_Aalpha_s", CaHVA_Aalpha_s);

    
   updateValue<double_t>(d, "CaHVA_Aalpha_u", CaHVA_Aalpha_u);

    
   updateValue<double_t>(d, "SK2_diro2", SK2_diro2);

    
   updateValue<double_t>(d, "HCN2_erev", HCN2_erev);

    
   updateValue<double_t>(d, "HCN1_Ehalf", HCN1_Ehalf);

    
   updateValue<double_t>(d, "KA_V0_binf", KA_V0_binf);

    
   updateValue<double_t>(d, "KA_Kbeta_a", KA_Kbeta_a);

    
   updateValue<double_t>(d, "KA_Kbeta_b", KA_Kbeta_b);

    
   updateValue<double_t>(d, "Lkg_gbar", Lkg_gbar);

    
   updateValue<double_t>(d, "KM_gbar", KM_gbar);

    
   updateValue<double_t>(d, "AMPA_scale_factor", AMPA_scale_factor);

    
   updateValue<double_t>(d, "Na_gbar", Na_gbar);

    
   updateValue<double_t>(d, "CaLVA_v0_m_inf", CaLVA_v0_m_inf);

    
   updateValue<double_t>(d, "NaP_gbar", NaP_gbar);

    
   updateValue<double_t>(d, "ca_d", ca_d);

    
   updateValue<double_t>(d, "AMPA_tp", AMPA_tp);

    
   updateValue<double_t>(d, "HCN2_tCs", HCN2_tCs);

    
   updateValue<double_t>(d, "CaLVA_k_h_inf", CaLVA_k_h_inf);

    
   updateValue<double_t>(d, "Na_erev", Na_erev);

    
   updateValue<double_t>(d, "NaP_V0_minf", NaP_V0_minf);

    
   updateValue<double_t>(d, "NaR_gbar", NaR_gbar);

    
   updateValue<double_t>(d, "AMPA_tau1", AMPA_tau1);

    
   updateValue<double_t>(d, "AMPA_tau2", AMPA_tau2);

    
   updateValue<double_t>(d, "ca_F", ca_F);

    
   updateValue<double_t>(d, "KA_V0alpha_b", KA_V0alpha_b);

    
   updateValue<double_t>(d, "KA_V0alpha_a", KA_V0alpha_a);

    
   updateValue<double_t>(d, "KA_Aalpha_b", KA_Aalpha_b);

    
   updateValue<double_t>(d, "KA_Aalpha_a", KA_Aalpha_a);

    
   updateValue<double_t>(d, "KM_Kbeta_n", KM_Kbeta_n);

    
   updateValue<double_t>(d, "CaLVA_v0_tau_m1", CaLVA_v0_tau_m1);

    
   updateValue<double_t>(d, "CaLVA_v0_tau_m2", CaLVA_v0_tau_m2);

    
   updateValue<double_t>(d, "KA_gbar", KA_gbar);

    
   updateValue<double_t>(d, "KA_erev", KA_erev);

    
   updateValue<double_t>(d, "HCN1_rB", HCN1_rB);

    
   updateValue<double_t>(d, "HCN1_rA", HCN1_rA);

    
   updateValue<double_t>(d, "KA_V0_ainf", KA_V0_ainf);

    
   updateValue<double_t>(d, "AMPA_tauA", AMPA_tauA);

    
   updateValue<double_t>(d, "AMPA_tauB", AMPA_tauB);

    
   updateValue<double_t>(d, "CaLVA_v0_tau_h2", CaLVA_v0_tau_h2);

    
   updateValue<double_t>(d, "CaLVA_v0_tau_h1", CaLVA_v0_tau_h1);

    
   updateValue<double_t>(d, "NaR_Abeta_s", NaR_Abeta_s);

    
   updateValue<double_t>(d, "comp19_V_t", comp19_V_t);

    
   updateValue<double_t>(d, "HCN2_Ehalf", HCN2_Ehalf);

    
   updateValue<double_t>(d, "CaLVA_v0_h_inf", CaLVA_v0_h_inf);

    
   updateValue<double_t>(d, "NaR_Abeta_f", NaR_Abeta_f);

    
   updateValue<double_t>(d, "ca2_ca2o", ca2_ca2o);

    
   updateValue<double_t>(d, "Na_e", Na_e);

    
   updateValue<double_t>(d, "Na_g", Na_g);

    
   updateValue<double_t>(d, "NaR_Kalpha_f", NaR_Kalpha_f);

    
   updateValue<double_t>(d, "SK2_dirc4", SK2_dirc4);

    
   updateValue<double_t>(d, "SK2_dirc3", SK2_dirc3);

    
   updateValue<double_t>(d, "SK2_dirc2", SK2_dirc2);

    
   updateValue<double_t>(d, "NaR_Kalpha_s", NaR_Kalpha_s);

    
   updateValue<double_t>(d, "KV_Aalpha_n", KV_Aalpha_n);

    
   updateValue<double_t>(d, "KCa_Bbeta_c", KCa_Bbeta_c);

    
   updateValue<double_t>(d, "NaR_e", NaR_e);

    
   updateValue<double_t>(d, "NaR_g", NaR_g);

    
   updateValue<double_t>(d, "KCa_Abeta_c", KCa_Abeta_c);

    
   updateValue<double_t>(d, "CaHVA_gbar", CaHVA_gbar);

    
   updateValue<double_t>(d, "KCa_g", KCa_g);

    
   updateValue<double_t>(d, "KCa_e", KCa_e);

    
   updateValue<double_t>(d, "HCN2_rA", HCN2_rA);

    
   updateValue<double_t>(d, "HCN2_rB", HCN2_rB);

    
   updateValue<double_t>(d, "SK2_invc1", SK2_invc1);

    
   updateValue<double_t>(d, "SK2_invc2", SK2_invc2);

    
   updateValue<double_t>(d, "SK2_invc3", SK2_invc3);

    
   updateValue<double_t>(d, "KCa_gbar", KCa_gbar);

    
   updateValue<double_t>(d, "Lkg_erev", Lkg_erev);

    
   updateValue<double_t>(d, "NaP_Kalpha_m", NaP_Kalpha_m);

    
   updateValue<double_t>(d, "KA_K_ainf", KA_K_ainf);

    
   updateValue<double_t>(d, "ca_cai0", ca_cai0);

    
   updateValue<double_t>(d, "HCN1_erev", HCN1_erev);

    
   updateValue<double_t>(d, "HCN1_gbar", HCN1_gbar);

    
   updateValue<double_t>(d, "KV_V0beta_n", KV_V0beta_n);

    
   updateValue<double_t>(d, "KA_V0beta_b", KA_V0beta_b);

    
   updateValue<double_t>(d, "KA_V0beta_a", KA_V0beta_a);

    
   updateValue<double_t>(d, "NaP_g", NaP_g);

    
   updateValue<double_t>(d, "NaP_e", NaP_e);

    
   updateValue<double_t>(d, "NaP_B_minf", NaP_B_minf);

    
   updateValue<double_t>(d, "NaR_erev", NaR_erev);

    
   updateValue<double_t>(d, "KCa_Aalpha_c", KCa_Aalpha_c);

    
   updateValue<double_t>(d, "ca2_ca2i0", ca2_ca2i0);

    
   updateValue<double_t>(d, "NaR_V0beta_s", NaR_V0beta_s);

    
   updateValue<double_t>(d, "SK2_erev", SK2_erev);

    
   updateValue<double_t>(d, "comp21_L", comp21_L);

    
   updateValue<double_t>(d, "KV_Kbeta_n", KV_Kbeta_n);

    
   updateValue<double_t>(d, "NaR_Aalpha_s", NaR_Aalpha_s);

    
   updateValue<double_t>(d, "Na_Kbeta_u", Na_Kbeta_u);

    
   updateValue<double_t>(d, "Na_Kbeta_v", Na_Kbeta_v);

    
   updateValue<double_t>(d, "KCa_Kalpha_c", KCa_Kalpha_c);

    
   updateValue<double_t>(d, "comp20_c", comp20_c);

    
   updateValue<double_t>(d, "CaLVA_valence", CaLVA_valence);

    
   updateValue<double_t>(d, "NaP_Aalpha_m", NaP_Aalpha_m);

    
   updateValue<double_t>(d, "HCN2_gbar", HCN2_gbar);

    
   updateValue<double_t>(d, "KM_erev", KM_erev);

    
   updateValue<double_t>(d, "ca2_beta", ca2_beta);

    
   updateValue<double_t>(d, "CaLVA_C_tau_h", CaLVA_C_tau_h);

    
   updateValue<double_t>(d, "NaP_V0beta_m", NaP_V0beta_m);

    
   updateValue<double_t>(d, "KV_Kalpha_n", KV_Kalpha_n);

    
   updateValue<double_t>(d, "HCN2_c", HCN2_c);

    
   updateValue<double_t>(d, "HCN2_e", HCN2_e);

    
   updateValue<double_t>(d, "HCN2_g", HCN2_g);

    
   updateValue<double_t>(d, "NaP_Abeta_m", NaP_Abeta_m);

    
   updateValue<double_t>(d, "comp19_celsius", comp19_celsius);

    
   updateValue<double_t>(d, "NaR_V0beta_f", NaR_V0beta_f);

    
   updateValue<double_t>(d, "CaHVA_Abeta_u", CaHVA_Abeta_u);

    
   updateValue<double_t>(d, "ca2_d", ca2_d);

    
   updateValue<double_t>(d, "CaLVA_shift", CaLVA_shift);

    
   updateValue<double_t>(d, "SK2_g", SK2_g);

    
   updateValue<double_t>(d, "HCN1_c", HCN1_c);

    
   updateValue<double_t>(d, "CaLVA_C_tau_m", CaLVA_C_tau_m);

    
   updateValue<double_t>(d, "CaLVA_A_tau_h", CaLVA_A_tau_h);

    
   updateValue<double_t>(d, "HCN1_e", HCN1_e);

    
   updateValue<double_t>(d, "SK2_e", SK2_e);

    
   updateValue<double_t>(d, "HCN1_g", HCN1_g);

    
   updateValue<double_t>(d, "CaLVA_A_tau_m", CaLVA_A_tau_m);

    
   updateValue<double_t>(d, "KV_gbar", KV_gbar);

    
   updateValue<double_t>(d, "ca2_F", ca2_F);

    
   updateValue<double_t>(d, "KM_Abeta_n", KM_Abeta_n);

    
   updateValue<double_t>(d, "NaP_erev", NaP_erev);

    
   updateValue<double_t>(d, "KM_V0alpha_n", KM_V0alpha_n);

    
   updateValue<double_t>(d, "HCN2_tEs", HCN2_tEs);

    
   updateValue<double_t>(d, "CaHVA_V0alpha_s", CaHVA_V0alpha_s);

    
   updateValue<double_t>(d, "NaP_Kbeta_m", NaP_Kbeta_m);

    
   updateValue<double_t>(d, "CaHVA_Abeta_s", CaHVA_Abeta_s);

    
   updateValue<double_t>(d, "CaHVA_V0alpha_u", CaHVA_V0alpha_u);

    
   updateValue<double_t>(d, "KM_V0_ninf", KM_V0_ninf);

    
   updateValue<double_t>(d, "Na_Aalpha_u", Na_Aalpha_u);

    
   updateValue<double_t>(d, "Na_Aalpha_v", Na_Aalpha_v);

    
   updateValue<double_t>(d, "KA_K_binf", KA_K_binf);

    
   updateValue<double_t>(d, "NaR_Kbeta_f", NaR_Kbeta_f);

    
   updateValue<double_t>(d, "NaR_Kbeta_s", NaR_Kbeta_s);

    
   updateValue<double_t>(d, "CaHVA_R", CaHVA_R);

    
   updateValue<double_t>(d, "CaHVA_V0beta_u", CaHVA_V0beta_u);

    
   updateValue<double_t>(d, "CaHVA_V0beta_s", CaHVA_V0beta_s);

    
   updateValue<double_t>(d, "ca_beta", ca_beta);

    
   updateValue<double_t>(d, "CaLVA_k_tau_h1", CaLVA_k_tau_h1);

    
   updateValue<double_t>(d, "CaLVA_k_tau_h2", CaLVA_k_tau_h2);

    
   updateValue<double_t>(d, "CaHVA_F", CaHVA_F);

    
   updateValue<double_t>(d, "HCN2_tEf", HCN2_tEf);

    
   updateValue<double_t>(d, "CaHVA_Kalpha_s", CaHVA_Kalpha_s);

    
   updateValue<double_t>(d, "CaHVA_Kalpha_u", CaHVA_Kalpha_u);

    
   updateValue<double_t>(d, "CaLVA_k_tau_m2", CaLVA_k_tau_m2);

    
   updateValue<double_t>(d, "KV_g", KV_g);

    
   updateValue<double_t>(d, "CaLVA_k_tau_m1", CaLVA_k_tau_m1);

    
   updateValue<double_t>(d, "CaHVA_g", CaHVA_g);

    
   updateValue<double_t>(d, "KV_e", KV_e);

    
   updateValue<double_t>(d, "KCa_Balpha_c", KCa_Balpha_c);

    
   updateValue<double_t>(d, "ca_cao", ca_cao);

    
   updateValue<double_t>(d, "HCN1_tCf", HCN1_tCf);

    
   updateValue<double_t>(d, "NaR_Shiftbeta_s", NaR_Shiftbeta_s);

    
   updateValue<double_t>(d, "CaLVA_gbar", CaLVA_gbar);

    
   updateValue<double_t>(d, "KM_e", KM_e);

    
   updateValue<double_t>(d, "Na_V0beta_u", Na_V0beta_u);

    
   updateValue<double_t>(d, "KM_g", KM_g);

    
   updateValue<double_t>(d, "Na_V0beta_v", Na_V0beta_v);

    
   updateValue<double_t>(d, "KV_V0alpha_n", KV_V0alpha_n);

    
   updateValue<double_t>(d, "ca2_valence", ca2_valence);

    
   updateValue<double_t>(d, "HCN1_tCs", HCN1_tCs);

    
   updateValue<double_t>(d, "KV_erev", KV_erev);

    
   updateValue<double_t>(d, "HCN2_tDs", HCN2_tDs);

    
   updateValue<double_t>(d, "Na_Kalpha_u", Na_Kalpha_u);

    
   updateValue<double_t>(d, "Na_Kalpha_v", Na_Kalpha_v);

    
   updateValue<double_t>(d, "HCN1_tDf", HCN1_tDf);

    
   updateValue<double_t>(d, "KM_Aalpha_n", KM_Aalpha_n);

    
   updateValue<double_t>(d, "HCN2_tCf", HCN2_tCf);

    
   updateValue<double_t>(d, "comp21_diam", comp21_diam);

    
   updateValue<double_t>(d, "Na_Abeta_v", Na_Abeta_v);

    
   updateValue<double_t>(d, "Na_Abeta_u", Na_Abeta_u);

    
   updateValue<double_t>(d, "KCa_erev", KCa_erev);

    
   updateValue<double_t>(d, "SK2_diff", SK2_diff);

    
   updateValue<double_t>(d, "CaHVA_Kbeta_u", CaHVA_Kbeta_u);

    
   updateValue<double_t>(d, "CaHVA_Kbeta_s", CaHVA_Kbeta_s);

    
   updateValue<double_t>(d, "Na_V0alpha_v", Na_V0alpha_v);

    
   updateValue<double_t>(d, "HCN2_tDf", HCN2_tDf);

    
    


   updateValue<double_t>(d, "celsius", celsius);

    
   updateValue<double_t>(d, "V_t", V_t);

    
    


   celsius  =  comp19_celsius;
   V_t  =  comp19_V_t;
    

}


void Golgi::State_::get (DictionaryDatum &d) const
{

   def<double_t>(d, "AMPA_A", y_[27]);

   def<double_t>(d, "AMPA_B", y_[26]);

   def<double_t>(d, "ca2_ca2", y_[25]);

   def<double_t>(d, "ca_ca", y_[24]);

   def<double_t>(d, "HCN2_o_slow", y_[23]);

   def<double_t>(d, "HCN1_o_fast", y_[22]);

   def<double_t>(d, "HCN1_o_slow", y_[21]);

   def<double_t>(d, "HCN2_o_fast", y_[20]);

   def<double_t>(d, "KM_m286", y_[19]);

   def<double_t>(d, "NaP_m302", y_[18]);

   def<double_t>(d, "KV_m291", y_[17]);

   def<double_t>(d, "NaR_h308", y_[16]);

   def<double_t>(d, "NaR_m307", y_[15]);

   def<double_t>(d, "CaLVA_h270", y_[14]);

   def<double_t>(d, "CaLVA_m269", y_[13]);

   def<double_t>(d, "Na_h297", y_[12]);

   def<double_t>(d, "KA_h276", y_[11]);

   def<double_t>(d, "KCa_m281", y_[10]);

   def<double_t>(d, "Na_m296", y_[9]);

   def<double_t>(d, "KA_m275", y_[8]);

   def<double_t>(d, "CaHVA_m263", y_[7]);

   def<double_t>(d, "SK2_SK2_zc4", y_[6]);

   def<double_t>(d, "SK2_SK2_zo2", y_[5]);

   def<double_t>(d, "SK2_SK2_zc3", y_[4]);

   def<double_t>(d, "SK2_SK2_zo1", y_[3]);

   def<double_t>(d, "SK2_SK2_zc2", y_[2]);

   def<double_t>(d, "CaHVA_h264", y_[1]);

   def<double_t>(d, "v", y_[0]);

    
    
   def<double_t>(d, names::V_m, y_[0]);

    
    
}
    
void Golgi::State_::set (const DictionaryDatum &d, const Parameters_&)
{

   updateValue<double_t>(d, "AMPA_A", y_[27]);

   updateValue<double_t>(d, "AMPA_B", y_[26]);

   updateValue<double_t>(d, "ca2_ca2", y_[25]);

   updateValue<double_t>(d, "ca_ca", y_[24]);

   updateValue<double_t>(d, "HCN2_o_slow", y_[23]);

   updateValue<double_t>(d, "HCN1_o_fast", y_[22]);

   updateValue<double_t>(d, "HCN1_o_slow", y_[21]);

   updateValue<double_t>(d, "HCN2_o_fast", y_[20]);

   updateValue<double_t>(d, "KM_m286", y_[19]);

   updateValue<double_t>(d, "NaP_m302", y_[18]);

   updateValue<double_t>(d, "KV_m291", y_[17]);

   updateValue<double_t>(d, "NaR_h308", y_[16]);

   updateValue<double_t>(d, "NaR_m307", y_[15]);

   updateValue<double_t>(d, "CaLVA_h270", y_[14]);

   updateValue<double_t>(d, "CaLVA_m269", y_[13]);

   updateValue<double_t>(d, "Na_h297", y_[12]);

   updateValue<double_t>(d, "KA_h276", y_[11]);

   updateValue<double_t>(d, "KCa_m281", y_[10]);

   updateValue<double_t>(d, "Na_m296", y_[9]);

   updateValue<double_t>(d, "KA_m275", y_[8]);

   updateValue<double_t>(d, "CaHVA_m263", y_[7]);

   updateValue<double_t>(d, "SK2_SK2_zc4", y_[6]);

   updateValue<double_t>(d, "SK2_SK2_zo2", y_[5]);

   updateValue<double_t>(d, "SK2_SK2_zc3", y_[4]);

   updateValue<double_t>(d, "SK2_SK2_zo1", y_[3]);

   updateValue<double_t>(d, "SK2_SK2_zc2", y_[2]);

   updateValue<double_t>(d, "CaHVA_h264", y_[1]);

   updateValue<double_t>(d, "v", y_[0]);

    

   updateValue<double_t>(d, names::V_m, y_[0]);

    
    
}




Golgi::Buffers_::Buffers_(Golgi& n)
    : logger_(n),
      s_(0),
      c_(0),
      e_(0),
      N(0),
      u(0),
      jac(0)
{
    // Initialization of the remaining members is deferred to
    // init_buffers_().
}


Golgi::Buffers_::Buffers_(const Buffers_&, Golgi& n)
    : logger_(n),
      s_(0),
      c_(0),
      e_(0),
      N(0),
      u(0),
      jac(0)
{
    // Initialization of the remaining members is deferred to
    // init_buffers_().
}




RecordablesMap<Golgi> Golgi::recordablesMap_;

template <> void RecordablesMap<Golgi>::create()
{

   insert_("AMPA_A", &Golgi::get_y_elem_<Golgi::State_::AMPA_A>);

   insert_("AMPA_B", &Golgi::get_y_elem_<Golgi::State_::AMPA_B>);

   insert_("ca2_ca2", &Golgi::get_y_elem_<Golgi::State_::CA2_CA2>);

   insert_("ca_ca", &Golgi::get_y_elem_<Golgi::State_::CA_CA>);

   insert_("HCN2_o_slow", &Golgi::get_y_elem_<Golgi::State_::HCN2_O_SLOW>);

   insert_("HCN1_o_fast", &Golgi::get_y_elem_<Golgi::State_::HCN1_O_FAST>);

   insert_("HCN1_o_slow", &Golgi::get_y_elem_<Golgi::State_::HCN1_O_SLOW>);

   insert_("HCN2_o_fast", &Golgi::get_y_elem_<Golgi::State_::HCN2_O_FAST>);

   insert_("KM_m286", &Golgi::get_y_elem_<Golgi::State_::KM_M286>);

   insert_("NaP_m302", &Golgi::get_y_elem_<Golgi::State_::NAP_M302>);

   insert_("KV_m291", &Golgi::get_y_elem_<Golgi::State_::KV_M291>);

   insert_("NaR_h308", &Golgi::get_y_elem_<Golgi::State_::NAR_H308>);

   insert_("NaR_m307", &Golgi::get_y_elem_<Golgi::State_::NAR_M307>);

   insert_("CaLVA_h270", &Golgi::get_y_elem_<Golgi::State_::CALVA_H270>);

   insert_("CaLVA_m269", &Golgi::get_y_elem_<Golgi::State_::CALVA_M269>);

   insert_("Na_h297", &Golgi::get_y_elem_<Golgi::State_::NA_H297>);

   insert_("KA_h276", &Golgi::get_y_elem_<Golgi::State_::KA_H276>);

   insert_("KCa_m281", &Golgi::get_y_elem_<Golgi::State_::KCA_M281>);

   insert_("Na_m296", &Golgi::get_y_elem_<Golgi::State_::NA_M296>);

   insert_("KA_m275", &Golgi::get_y_elem_<Golgi::State_::KA_M275>);

   insert_("CaHVA_m263", &Golgi::get_y_elem_<Golgi::State_::CAHVA_M263>);

   insert_("SK2_SK2_zc4", &Golgi::get_y_elem_<Golgi::State_::SK2_SK2_ZC4>);

   insert_("SK2_SK2_zo2", &Golgi::get_y_elem_<Golgi::State_::SK2_SK2_ZO2>);

   insert_("SK2_SK2_zc3", &Golgi::get_y_elem_<Golgi::State_::SK2_SK2_ZC3>);

   insert_("SK2_SK2_zo1", &Golgi::get_y_elem_<Golgi::State_::SK2_SK2_ZO1>);

   insert_("SK2_SK2_zc2", &Golgi::get_y_elem_<Golgi::State_::SK2_SK2_ZC2>);

   insert_("CaHVA_h264", &Golgi::get_y_elem_<Golgi::State_::CAHVA_H264>);

   insert_("v", &Golgi::get_y_elem_<Golgi::State_::V>);


   insert_(names::V_m, &Golgi::get_y_elem_<Golgi::State_::V>);


}



Golgi::Golgi()
    : Archiving_Node(), 
      P_(), 
      S_(P_),
      B_(*this)
{
    recordablesMap_.create();
}


Golgi::Golgi(const Golgi& n)
    : Archiving_Node(n), 
      P_(n.P_), 
      S_(n.S_),
      B_(n.B_, *this)
{
}


Golgi::~Golgi ()
{
    // GSL structs only allocated by init_nodes_(), so we need to protect destruction
    if ( B_.s_ != NULL) gsl_odeiv2_step_free (B_.s_);
    if ( B_.c_ != NULL) gsl_odeiv2_control_free (B_.c_);
    if ( B_.e_ != NULL) gsl_odeiv2_evolve_free (B_.e_);
    if ( B_.u != NULL) free (B_.u);
    if ( B_.jac != NULL) free (B_.jac);
}


void Golgi::init_node_(const Node& proto)
{
    const Golgi& pr = downcast<Golgi>(proto);
    P_ = pr.P_;
    S_ = State_(P_);
}


void Golgi::init_state_(const Node& proto)
{
    const Golgi& pr = downcast<Golgi>(proto);
    S_ = State_(pr.P_);
}


void Golgi::init_buffers_()
{
      B_.spike_comp24.clear();
   
   B_.currents_.clear();           
   Archiving_Node::clear_history();

   B_.logger_.reset();

   B_.step_ = Time::get_resolution().get_ms();
   B_.IntegrationStep_ = B_.step_;

   B_.I_stim_ = 0.0;


   static const gsl_odeiv2_step_type* T1 = gsl_odeiv2_step_rk2;
   B_.N = 28;
  
   if ( B_.s_ == 0 )
     B_.s_ = gsl_odeiv2_step_alloc (T1, B_.N);
   else 
     gsl_odeiv2_step_reset(B_.s_);
    
   if ( B_.c_ == 0 )  
     B_.c_ = gsl_odeiv2_control_standard_new (1e-7, 
                                              1e-7, 1.0, 0.0);
   else
     gsl_odeiv2_control_init(B_.c_, 1e-7, 
                             1e-7, 1.0, 0.0);
    
   if ( B_.e_ == 0 )  
     B_.e_ = gsl_odeiv2_evolve_alloc(B_.N);
   else 
     gsl_odeiv2_evolve_reset(B_.e_);
   
   B_.sys_.function  = Golgi_dynamics; 
   B_.sys_.jacobian  = Golgi_jacobian;
   B_.sys_.dimension = B_.N;
   B_.sys_.params    = reinterpret_cast<void*>(this);

   B_.u = (double *)malloc(sizeof(double) * B_.N);
   assert (B_.u);
   B_.jac = (double *)malloc(sizeof(double) * B_.N);
   assert (B_.jac);

}


void Golgi::calibrate()
{
    B_.logger_.init();  
    V_.U_old_ = S_.y_[0];    V_.RefractoryCounts_ = 0;
}







inline int Golgi::AMPA_transients (long_t lag)
{
   double AMPA_scale_factor, AMPA_w, w, AMPA_A, AMPA_B;

  w = B_.spike_comp24.get_value(lag);
  if (w > 0.0)
  {
     AMPA_w  =  w;
     AMPA_scale_factor = P_.AMPA_scale_factor;     AMPA_B  =  Ith(S_.y_,26);     AMPA_B  =  AMPA_B + AMPA_w * AMPA_scale_factor;     Ith(S_.y_,26)  =  AMPA_B;     AMPA_scale_factor = P_.AMPA_scale_factor;     AMPA_A  =  Ith(S_.y_,27);     AMPA_A  =  AMPA_A + AMPA_w * AMPA_scale_factor;     Ith(S_.y_,27)  =  AMPA_A;
     return 1;
  }

  return 0;
}



    
  void Golgi::update(Time const & origin, const long_t from, const long_t to)
  {

    assert(to >= 0 && (delay) from < Scheduler::get_min_delay());
    assert(from < to);

    double tout;
    long_t current_steps = origin.get_steps();

    for ( long_t lag = from ; lag < to ; ++lag )
      {
        double h = B_.step_;    
	double tt = 0.0 ; 


        V_.U_old_ = S_.y_[0];

        while (tt < h)
        {

           const int status = 
             gsl_odeiv2_evolve_apply
             (B_.e_, B_.c_, B_.s_, 
              &B_.sys_, // system of ODE
              &tt, // from t...
              h, // ...to t=t+h
              &B_.IntegrationStep_, // integration window (written on!)
              S_.y_); // neuron state

           if ( status != GSL_SUCCESS )
             throw GSLSolverFailure(get_name(), status);

        }
        
        


         if ( S_.r_ > 0 )
	    S_.r_--;
         else
	    if (S_.y_[0] >= P_.V_t && V_.U_old_ > S_.y_[0])
	      {
                S_.r_ = V_.RefractoryCounts_;
		set_spiketime(Time::step(origin.get_steps()+lag+1));
		SpikeEvent se;
		network()->send(*this, se, lag);
	      };


        

  int events = 0;

  events = events + AMPA_transients (lag);


  /* Resets the GSL stepping function if any synaptic events have occurred */
  if (events > 0)
  {
     gsl_odeiv2_step_reset (B_.s_);
  }


        B_.I_stim_ = B_.currents_.get_value(lag);
        B_.logger_.record_data(current_steps + lag);
      }
  }



  
void Golgi::handle(SpikeEvent & e)
  {
    int flag;
    assert(e.get_delay() > 0);
    flag = 0;

    if ((flag==0) && (e.get_rport() == AMPA_SPIKE_RECEPTOR ) && 
        (e.get_weight() > 0.0))
      {
	B_.spike_comp24.add_value(e.get_rel_delivery_steps(network()->get_slice_origin()),
			                           fabs(e.get_weight()) * e.get_multiplicity());
        flag = 1;
      }

  }


void Golgi::handle(CurrentEvent& e)
  {
    assert(e.get_delay() > 0);

    const double_t c = e.get_current();
    const double_t w = e.get_weight();

    B_.currents_.add_value(e.get_rel_delivery_steps(network()->get_slice_origin()), w * c);
  }


void Golgi::handle(DataLoggingRequest& e)
  {
    B_.logger_.handle(e);
  }
}
